.TH petlp 1 "21 Nov 1995" "DEMOS" "C64 Program Development"
.nr X
.SH NAME
petlp \- print PETSCII files
.SH SYNOPSIS
.IR petlp
[
.B \-c
|
.B \-nc
] [
.B \-latin
|
.B \-graph
] [
.B \-lang \fIlangname\fR
] [
.B \-upper
|
.B \-lower
|
.B \-business
] [
.B \-left \fIcolumn\fR
] [
.B \-right \fIcolumn\fR
] [
.B \-top \fIrow\fR
] [
.B \-bop \fIrow\fR
] [
.B \-o \fIfilename\fR
] [
.B \-F \fIformat\fR
] [
.B \-P \fIprinter\fR
] [
\--
] [
.B file list
]
.SH DESCRIPTION
.IR petlp
converts input files from the PETSCII encoding to
printable ASCII or ISO 8859/1 and writes to a file or sends to laser printer.
The type of input file can be selected from these formats, and
appropriate conversion is performed.
.SH OPTIONS
.TP 8
.B \-c
Causes
.IR petlp
to interpret also control characters.
By default, these strings are the same as used by printers.
.TP
.B \-nc
Suppress control codes.
.TP
.B \-latin

.TP
.B \-graph

.TP
.B \-lang \fInationality\fR

.TP
.B \-upper

.TP
.B \-lower

.TP
.B \-business

.TP
.B \-left \fIcolumn\fR

.TP
.B \-right \fIcolumn\fR

.TP
.B \-top \fIrow\fR

.TP
.B \-bot \fIrow\fR

.TP
.B \-o \fIfilename\fR
Redirect output to the specified \fIfile\fR.
.TP
.B \-F \fIformat\fR
Select format (i.e. encoding) for the file to be printed in.
Available formats are:
 "binary", "log", "petcii", "ascii", "Latin/1", "PS"
.TP
.B \-P \fIprinter\fR

.TP
.B \-\-
Mark explicitly the end of any command line options, allowing
.IR petlp
to recognize filename arguments that begin with a -.
.TP
.B file list
Input files to be printed.
.SH EXAMPLES
.PD 1
.BD 0
.TP 8

.LP
.RS
.ft 4
petlp -test
petlp -test -F PS -o test.ps
.ft 1
.RE
.LP
Produce the printer Self Test pattern.
.LP
.RS
.ft 4
petlp -lower -lang finland -left 4
.ft 1
.RE
.LP

.LP
.RS
.ft 4
petlp -ascii -lower
.ft 1
.RE
.LP
The normal PETSCII to ASCII conversion
.LP
.RS
.ft 4
c1541 -r diskimage filename - | petcat | petlp -f PS -o file.ps
.ft 1
.RE
.LP
Prints a BASIC program \fIfilename\fR from disk \fIimagename\fR to postscript
file \fIfile.ps\fR.
.SH RESTRICTIONS
.LP
Control codes that appear outside quotes are not interpreted.
Graphics commands are only available on Postscript output.
.SH SEE ALSO
.BR cat (1),
.BR tr (1),
.BR sed (1),
.BR petcat (1),
.BR cbmconvert,
.BR iso2asc (1),
.BR a2ps (1),
.BR mpage (1),
.BR ASCII (7),
.BR "CBM's \fIProgrammers' Reference Guide\fP series"
.SH AUTHORS
  Jarkko Sonninen (sonninen@lut.fi)
  Jouko Valta     (jopi@stekt.oulu.fi)
  Hannu Helminen  (dm@stekt.oulu.fi)
