.TH VICE N "1 April 1996" "X Version 11" "Versatile Commodore Emulator"
.SH NAME
x64, x128, xvic, xpet, c1541 \- Commodore Emulator And Program Development System for X display
.SH SYNOPSIS
.B x64
    [-asm] [-basicName \fIvalue\fP] [-brevision \fIvalue\fP]
    [-/+checksb] [-/+checkss] [-debug] [-directory \fIvalue\fP]
    [-display \fIvalue\fP] [-exrom \fIvalue\fP]
    [-floppy \fIvalue\fP] [-8 \fIvalue\fP] [-9 \fIvalue\fP]
    [-fn \fIvalue\fP] [-halt] [-/+hex] [-hjoyport \fIvalue\fP]
    [-joyport \fIvalue\fP] [-kernel \fIvalue\fP] [-load \fIvalue\fP]
    [-module \fIvalue\fP] [-game \fIvalue\fP] [-/+mitshm]
    [-printCommand \fIvalue\fP] [-ram \fIvalue\fP] [-refresh \fIvalue\fP]
    [-reu \fIvalue\fP] [-revision \fIvalue\fP] [-start \fIvalue\fP]
    [-speed \fIvalue\fP] [-tape \fIvalue\fP] [-1 \fIvalue\fP] [-test]
    [-/+traps] [-verbose]

.B x128
    [-/+40] [-/+80] [-asm] [-basic \fIvalue\fP] [-bios \fIvalue\fP]
    [-brevision \fIvalue\fP] [-/+checksb] [-/+checkss] [-debug]
    [-directory \fIvalue\fP] [-display \fIvalue\fP] [-exrom \fIvalue\fP]
    [-floppy \fIvalue\fP] [-8 \fIvalue\fP] [-9 \fIvalue\fP]
    [-fn \fIvalue\fP] [-halt] [-/+hex] [-hjoyport \fIvalue\fP]
    [-joyport \fIvalue\fP] [-kernel \fIvalue\fP] [-load \fIvalue\fP]
    [-module \fIvalue\fP] [-game \fIvalue\fP] [-/+mitshm]
    [-printCommand \fIvalue\fP] [-ram \fIvalue\fP] [-reu \fIvalue\fP]
    [-revision \fIvalue\fP] [-start \fIvalue\fP] [-speed \fIvalue\fP]
    [-tape \fIvalue\fP] [-1 \fIvalue\fP] [-test] [-/+traps]
    [-vdcrefresh \fIvalue\fP] [-verbose] [-vicrefresh \fIvalue\fP]

.B xpet
    [-/+40] [-/+80] [-asm] [-basic \fIvalue\fP] [-debug]
    [-directory \fIvalue\fP] [-display \fIvalue\fP] [-exrom \fIvalue\fP]
    [-floppy \fIvalue\fP] [-8 \fIvalue\fP] [-9 \fIvalue\fP]
    [-fn \fIvalue\fP] [-halt] [-/+hex] [-kernel \fIvalue\fP]
    [-load \fIvalue\fP] [-module \fIvalue\fP] [-game \fIvalue\fP]
    [-/+mitshm] [-printCommand \fIvalue\fP] [-ram \fIvalue\fP]
    [-refresh \fIvalue\fP] [-start \fIvalue\fP] [-speed \fIvalue\fP]
    [-tape \fIvalue\fP] [-1 \fIvalue\fP] [-test] [-/+traps] [-verbose]
 
.B xvic
    [-asm] [-basic \fIvalue\fP] [-debug] [-directory \fIvalue\fP]
    [-display \fIvalue\fP] [-exrom \fIvalue\fP] [-floppy \fIvalue\fP]
    [-8 \fIvalue\fP] [-9 \fIvalue\fP] [-fn \fIvalue\fP] [-halt]
    [-/+hex] [-hjoyport \fIvalue\fP] [-joyport \fIvalue\fP]
    [-kernel \fIvalue\fP] [-load \fIvalue\fP] [-module \fIvalue\fP]
    [-game \fIvalue\fP] [-/+mitshm] [-printCommand \fIvalue\fP]
    [-ram \fIvalue\fP] [-refresh \fIvalue\fP] [-start \fIvalue\fP]
    [-speed \fIvalue\fP] [-tape \fIvalue\fP] [-1 \fIvalue\fP] [-test]
    [-/+traps] [-verbose]


.B c1541 \fIoption\fP \fIdiskname\fP [\fIparameters\fP]
.br
.B c1541 [\fIdiskname\fP ... ]

.SH DESCRIPTION
.B x64, x128, xpet 
and
.B xvic
are powerful Commodore 8-bit machine emulators with a Machine Language
Monitor built-in.  For the best possible compatibility they emulate
the hardware so that the original basic and kernel routines can be
used. Exact 6502/6510/8502 emulation is provided, as well as
peripheral support consisting of printers and disk drives. Thus, they
are capable to run most of the Commodore 8 bit software, provided that
the host machine is able to support the needed computing power. They
support special features, including split screens and rasterline
effects on real-time.  Both command line options and a run-time
interface are provided to select the desired parameters and a variety
of other features in order to obtain best performance in any
situation. Sound is not supported yet.
.br
Also a printer emulation is provided, supporting nationalized character
sets of the Commodore family, to help processing text files in Commodore
format.
In order to make the best use of the printer emulation you should make
sure it is configured to suit your purposes. Especially series 3 LaserJets
and matrix printers are prone to jam upon encountering 8 bit characters.
On the other hand, use of bare standard ASCII causes a wide variety of
characters to be lost.
.SH OPTIONS
.TP 8
.B \-1 \fItape\fP
attach a T64 tape image. (x128 and x64 only)
.TP
.B \-8 \fIdisk\fP
.B \-9 \fIdisk\fP
attach a D64 or X64 disk image as drive 8 or 9, respectively.
.TP
.B \-40
enables the 40 column display (default).
On
.B xpet
the kernel must support the screen width specified. (x128 and xpet only)
.TP
.B \-80
enables the 80 column display. If both 40 and 80 column are turned on, the C128
emulator boots up on the 80 column mode. (x128 and xpet only)
.TP
.B \-asm
starts the Machine Language Monitor upon initialization.
.TP
.B \-basic \fIfilename\fP
specifies the name for the BASIC ROM (default is "basic").
.TP
.B \-bload \fIprogram_name\fP [\fIload_address\fP]
loads a machine language program into RAM. Again, there has to be the
start address included in the beginning of the program.
Via specifying the \fIload_address\fP, user can, however intruct the
program to be loaded different place than the \fIload_address\fP
assumes.
.TP
.B \-brevision \fIrevision\fP
if installed in compilation, changes loaded C128 Basic code so that you
can use whichever \fIrevision\fP ('85' or '86') you select.
.TP
.B \+checkss
disables sprite to sprite collision checking. (x64 and x128 only) 
.TP
.B \-checkss
enables sprite to sprite collision checking. (x64 and x128 only)
.TP
.B \+checksb
disables sprite to background collision checking. (x64 and x128 only)
.TP
.B \-checksb
enables sprite to background collision checking. (x64 and x128 only)
.TP
.B \-debug
selects debug mode.
.B \-display \fIdisplayname\fP
selects a remote display for executing the emulator.
.TP
.B \-directory \fIpath\fP 
sets the path for project directory.
.TP
.B \-exrom \fIexrom\fP
specifies the file to be loaded to cartridge ROM slot with the -module
option. The default name is "exrom".
.TP
.B \-halt
opens the debug window and halt the emulator. This allows tracing any
instructions from the very beginning.
.TP
.B \-floppy \fIdisk\fP
same as `-8'.
.TP
.B \-fn \fIfontname\fP
specifies a font for the XDebugger. It should be of the of a fixed type.
.TP
.B -hex
activate hex mode (default). This will affect all the numbers entered
in the built-in monitor.
.B +hex
activate the decimal mode.
.TP
.B \-joyport \fIport\fP 
selects the joystick port to use for the emulation via keypad.
The default value is 2.
(x64, x128 and xvic only)
.TP
.B \-hjoyport \fIport\fP
selects the joystick port to use for the hardware joystick (Linux only).
The default value is 3 - joyport.
.TP
.B \-kernel \fIfilename\fP
specifies the name for the Kernal ROM (default is "kernel").
.TP
.B \-load \fIprogram_name\fP
loads a program into ram. There has to be the start address
included in the beginning of the program.
Also \fIstart_address\fP for the emulator should be set to the system
warm start (break) vector with
\-start option when loading BASIC programs, so that Basic 'NEW' is not
performed automatically.
.TP
.B \-mitshm
enables shared memory. This will speed up the operation on the console and
is highly recommended.
.B \+mitshm
disables shared memory usage (use this option only if you use a remote
X-Terminal or it gives you problems).
.TP
.B \-module \fIn\fP
selects the memory area where the \fIexrom\fP module is located:
.br
1 = 8000-9FFF
2 = A000-BFFF
3 = 8000-BFFF
.TP
.B \-refresh \fIrate\fP 
sets the screen refresh rate. Default is set to every 4 frames.
.TP
.B \-reu \fIreufile\fP
if installed in compilation, activates the RAM Expansion Unit and
specifies the filename for RAM image of the REU.
Existing file is loaded to memory upon startup.
The default filename is "reu".
.TP
.B \-revision \fIrevision\fP
if installed in compilation, changes loaded Kernal code so that you
can use whichever \fIrevision\fP you select.
.br
For the 64, the alternatives are: 0, 3, 67 and 100.
.br
For the 128: 1 = Swedish, 2 = German, 3 = American.
.TP
.B \-speed \fIpercent\fP 
sets the speed limit for emulation. Specifying 0 enables the operation at
full tilt.
.TP
.B -start \fIstart_address\fP
address of the power-up initialization routine. The default
is RESET (FCE2).
With a BASIC program being loaded, better result may be achieved by
using the BASIC warm start vector (FE66) instead.
.TP
.B -tape \fIfilename\fP
same as `-1'.
.B \+traps
disables the Kernel traps used for Serial Bus emulation, and thus
the bus too.
.TP
.B \-traps
enables the Kernel traps (default).
.TP
.B \-verbose
selects verbose mode.
.SH DEFAULTS
.SS Environment Variables
.PP
To select the default X server to connect to
.br
.ne 8
.IP
setenv DISPLAY "`uname -n`:0"
.PP
If you have 8-bit ;) machine, add the following line to your .login:
.br
.ne 8
.IP
setenv LC_CTYPE iso_8859_1
.SS X Application Resources
Under construction.
.SH USAGE
.SS Keyboard Layout
.TP 8
The following keys have special meaning:
.TP 16
.B "F1 F2 F3 F4 F5 F6 F7 F8"
the function keys: for proper operation, you should configure your 
favourite window manager so that it does not use them;
.TP
.B  asciicircum or asciitilde
up arrow (on US and scandinavian keyboards respectively);
.TP
.BI underscore
left arrow;
.TP
.BI bar
Pound Sign;
.TP
.BI Backspace;
Delete;
.TP
.BI Linefeed
Shifted Return;
.TP
.BI Control_L
Control;
.TP
.BI Alt_L
CBM Key (Press down Left Shift and then Alt to change character set.);
.TP
.BI Escape
STOP;
.TP
.BI Tab
Restore;
.TP
.BI Shift_R
`invisible shift': it can be used to achieve characters which are shifted on the 
actual keyboard but unshifted on the emulated one.
.SS Joystick
On x128, xvic and x64, the numeric keypad emulates a `virtual'
joystick, plugged into the port specified by the 
.B -joyport 
option or the 
.B joyport
monitor variable (see the `set' command in the \fImonitor\fP section for more information). 
The keys operate as follows:
.P
.B 8
\: joystick up;
.PP
.B 2
\: joystick down;
.PP
.B 4
\: joystick left;
.PP
.B 6
\: joystick right;
.PP
.B 0
(zero) : fire.
.PP
True joystick is available on Linux only, with the proper kernel patch.
It will be plugged in the port which is not used by the keypad joystick.
.SS Mouse
The left mouse button halts the emulator and starts the
.B
Monitor.
.PP
The right mouse button will open and close a
.B Control
.B Window,
which contains useful gadgets as well as some debug information.
.SS Control Window
Whenever the XDebugger is enabled at compilation time, Control Window is
available with step-by-step execution and program trace ability.
.br
The left side of the Control Window displays the part of program the CPU
is executing. User can scroll the viewing area when execution is halted,
by using the slider or cursor keys within the subwindow.
.br
The upper right part of the Control Window displays the 6510 registers with
their current content.
.br
In the lower right corner are gadgets for controlling the emulator:
.TP 10
.BI Trace
causes
the assembly window to be updated each time a new intruction is to be run;
.TP
.BI Stop
enforces the emulator to halt.
.PP
Two additional functions are available while the emulator is halted:
.TP
.BI Cont
resumes the emulator;
.TP
.BI Step
CPU performs the next consecutive machine language instruction.
.SS Tracing a Routine
.LP
In order to follow excution of a machine language routine step by step,
you need to freeze the emulator.
.br
First, open the
.B Control
.B Window
with the right mouse button and click
.B Stop.
Return the pointer to the CBM display window and press the left 
mouse button to enter
.B Monitor.
Now, set the 6502 registers with appropriater values and enter a jump
command. (Typing 'x' has the same effect, if PC was correctly set.)
.br
The Xdebugger can now be used to follow progress of your routine.
.SS Tracing the Basic Interpreter
.LP
Write the command, except for RETURN, and either stop the execution,
or use
.B trace
command on the monitor. In addition, send the press of RETURN indirectly:
 > 277 0d
 > c6 1

.SH MONITOR
The
.B Monitor
has a small shell with command line editor and history utility controlled via
the cursor keys.
.pp
The following monitor commands are implemented:
.PD 1
.TP 8
.B "# % & $"
Numeric base conversion prefixes
.br
Decimal, Binary, Octal, and Hex respectively.
.TP
.B ">" \fIaddr\fP "\fIbytes|'string'\fP"
Writes data into memory.
.TP
.B ":" \fIaddr\fP "\fIbytes|'string'\fP"
Writes image data (e.g. sprites) into memory.
The values are represented by sequense of '-' and '*' for '0' and '1'
respectively.
.TP
.B ";" [\fIregisters\fP]
Same as 'registers'
.TP
.B ? [\fItopic\fP]
Help
.TP
.B asm [\fIaddr\fP]
Enters to line interpreter. `x' returns to command mode.
.br
The following syntax is used on input:
.br
[\fIaddr\fP] \fImnemonic\fP [\fIoperand\fP]
.TP
.B attach [#\fIdevice\fP] [\fIimagename\fP]
Attaches a floppy disk image file \fIimagename\fP for use on \fIdevice\fP.
Without \fIimagename\fP only detaches the previous one.
Also  note that the '#' before \fIdevice\fP number is required.
.TP
.B break [\fIstart\fP] [\fIend\fP]
Sets up breakpoints (region). New timer code only.
.TP
.B call [\fIaddr\fP]
Runs code at address specified.
.TP
.B clear \fIstart\fP [\fIend\fP]
Clears the breakpoints in the specified region. New timer code only.
.TP
.B compare \fIstart\fP \fIend|+len\fP "\fItarget\fP"
.TP
.B disassemble [\fIaddr\fP] [\fIend|+len\fP]
.TP
.B dump [\fIfilename\fP]
Saves ram image to a file.
.TP
.B fill \fIstart\fP \fIend|+len\fP "\fIbytes|'string'\fP"
.TP
.B help [\fItopic\fP]
Shows the description of the specified monitor command or the addressing modes
for 65xx mnemonic. Without any parameters, displays the list of
available commands.
.TP
.B hunt \fIstart\fP \fIend|+len\fP "\fIbytes|'string'\fP"
.TP
.B image [\fIaddr\fP] [\fIend|+len\fP]
Displays memory dump in bit format.
.TP
.B jump [\fIaddr\fP [\fIregisters\fP]]
Runs code at address specified. If specified, CPU registers are set using
.BI registers
command described below.
.TP
.B load \fIfilename\fP [\fIaddr\fP]
Loads a program into memory emulating the Kernal load routine.
.TP
.B memory [\fIaddr\fP] [\fIend|+len\fP]
Displays memory dump in hex format.
.TP
.B number \fIstart\fP \fIend|+len\fP \fIorig.st\fP [\fIorig.end\fP] [\fIdisp\fP]
Relinks code.
.TP
.B registers [\fIregisters\fP]
Show or change the 6510 registers (PC AC XR YR PF SP).
.TP
.B save \fIfilename\fP \fIaddr\fP \fIend|+len\fP
Saves memory area.
.TP
.B set [\fIvariable\fP \fIvalue\fP]
Without parameters, it displays all accessible system variables and the values
assigned to each.
To set a value, it must be specified with respect to the number base currently
activated (default base is set by the -hex option). If you want to use
a different base without changing the default one, you can use the `#', `$',
`&' or `%' prefixes. For example, to set the operating speed to 100%, use
.B set speed #100.
.TP
.B unset \fIvariable\fP
Unsets a system variable.
.TP
.B time [\fIaddr\fP]
Calls \fIaddr\fP and displays the amount of 6502 time used until
a \fIBRK\fP instruction is encountered. Without parameters the
previous time is displayed.
.TP
.B transfer \fIstart\fP \fIend|+len\fP \fIdest\fP
Moves a memory area.
.TP
.B undump \fI[filename]\fP
Loads a ram image from a file.
.TP
.B x
Exits the Monitor, i.e. returns to emulator.
.TP
.B quit
Exits the \fIx64\fP
.br
.TP 8
Note: All commands may be abbreviated.

.SH DISK DRIVE
.B x64
offers you also disk drive emulator which can be compiled as a
separate program as well. The 1541 emulation uses now binary files of
length 170kb as 35-track floppy disks.
Currently only PRG and SEQ file types and the most important DOS commands,
including some block operations are supported.
.br
There are up to four disk drives provided: #8 trough #10 simulate the 1541,
while #11 reads directly from the filesystem. There is also the standalone
program,
.B c1541
for maintaining the disk images. It can be operated from command line or
interactively.
.br
.TP 8
.B c1541 -\fIcommand\fP \fIdiskname\fP \fIparameters\fP
.TP
.B c1541 [\fIdiskname ...\fP]
Enters interactive mode with maximum 2 disk images.
.br
Syntax:
.B \fIcommand\fP [\fIparameters\fP]
.LP
To create a VICE Disk Image, use the
.BI format
or
.BI create
command on
.B c1541
.SS C1541 Commands
.LP
Note that the \fIdiskname\fP is not given as command argument
in interactive mode.
.br
The following commands are supported on c1541:
.TP 8
.PD 0
.B format \fIdiskname\fP 'name,id'
.TP
Format \fIdiskname\fP. Creates the file if needed.
.PD 1
.TP
.B delete \fIdiskname\fP files
Delete files on \fIdiskname\fP.
.TP
.B list \fIdiskname\fP [\fIpattern\fP]
List files on \fIdiskname\fP
.TP
.B validate \fIdiskname\fP
Validate disk.
.TP
.B copy \fIdiskname\fP \fIoldname\fP [\fIoldname2\fP ...] \fInewname\fP
Copy or concatenate files.
.TP
.B create \fIdiskname\fP \fIdump\fP ['\fIdescription\fP']
Make disk \fIdiskname\fP out of raw blockdump (683 blocks with 256 bytes each).
.TP
.B tape \fItapeimage\fP [\fIfiles\fP]
Copy files from tape image.
If a complete tape is being imported and there is a file called "file" on it,
.B C1541
attempts to use the \fItapeimage\fP name instead.
.TP
.B read \fIdiskname\fP \fI1541name\fP [\fIfsname\fP]
Read \fI1541name\fP on image into file \fIfsname\fP.
If `-' is given in place of \fIfsname\fP, write to stdout.
When \fIfsname\fP has extension `.P00', the PC64 file header is written
automatically. .P00 file cannot be written on stdout but to a file only.
.TP
.B write \fIdiskname\fP \fIfsname\fP [\fI1541name\fP]
Write file \fIfsname\fP onto image as \fI1541name\fP.
.TP
.B info \fIdiskname\fP ['\fIdescription\fP']
Show information on \fIdiskname\fP and 1541 version.
If \fIdescription\fP is given, write it into the image header.
.LP
There are few more commands not available in direct mode:
.TP 8
.B attach [\fIdrive\fP] \fIimagename\fP
Attaches floppy image for use on \fIdrive\fP.
.TP
.B block [\fIdrive\fP:] [\fItrack\fP [\fIsector\fP [\fIdisp\fP]]]
Display hex dump for one disk sector.
.TP
.B help
Display list of available commands.
.TP
.B unit [\fIdevice\fP]
Change default disk drive to \fIdevice\fP.
.TP
.B quit
Quits
.B c1541.
.br
.TP 8
Note: All commands may be abbreviated.
.pp
.SS Examples
.PD 1
.BD 0
.TP 8
First\, a disk image has to be formatted in a file\, say test.dsk:
.LP
.RS
.ft 4
c1541 -f test.dsk 'DISKI,ID'
.ft 1
.RE
.LP
to move programs to it one may type e.g.:
.LP
.RS
.ft 4
c1541 -w test.dsk pieces_of_light PIECESOFLIGHT
.ft 1
.RE
.LP
Finally\, start the emulator with option:
.LP
.RS
.ft 4
x64 -floppy test.dsk
.ft 1
.RE
.LP
or use the Monitor command
.LP
.RS
.ft 4
attach test.dsk
.ft 1
.RE
.LP
After that you can load programs in emulator with simple
.LP
.RS
.ft 4
LOAD "$",8
.br
LOAD "PIECESOFLIGHT",8
.br
.ft 1
etc.
.RE
.LP
Loading normal C64 program file:
.LP
.RS
.ft 4
x64 -load progname -start fe66
.ft 1
.RE
.SH FILES
.PD 1
The following are reserved filenames, normally located in the
\fIproject directory\fP:
.TP 16
.B basic
The BASIC ROM Image
.TP
.B kernel
The KERNEL ROM Image
.TP
.B chargen
The CHARACTER ROM Image. If this file is not found, the
emulator uses default character set instead.
.TP
.B ram
Completed execution RAM Image
.TP
.B exrom
Cartridge ROM Image
.TP
.B reu
RAM Expansion Image
.br
The REU size can be defined at compilation time to 128, 256 or 512 KB.
.TP
.B inst
Debug information about executed program.

.SH SEE ALSO
.LP
.BR sed (1),
.BR tr (1),
.BR vi (1),
.BR fvcbm (1),
.BR cbmconvert,
.BR petcat (N),
.BR iso2asc (1),
.BR ASCII (7),
.BR xmodmap (1),
.BR xkeymaped (N),
.BR xkeycaps (1),
.BR X (1),
.BR sysinfo (1),
.BR "\fIX Toolkit documentation\fP",
CBM's \fIProgrammers' Reference Guide\fP series

.SH BUGS
.LP
Since this program is under development, bugs are included for free.
.br
Please send your patches, bug reports and bug fixes to jopi@stekt.oulu.fi.

.SH RESTRICTIONS
.LP
VIC20, C64, C128 and PET basics and kernels are still under copyright,
and thus not included in the emulator. You have to grab your own copy
of them.
.br
Note: The ROMs are not interchangeable.

To prevent fatal shock hazard do not disassemble nor hexdump this program.
No user crackable routines inside.

.SH COPYRIGHT
Copyright (c) 1993,1994,1995,1996  Jarkko Sonninen, Teemu Rantanen,
Jouko Valta, Ettore Perazzoli and Andre Fachat.

The Zilog Z80 CPU Emulator Copyright (C) Marat Fayzullin 1994,1995,1996

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
.br


.SH AUTHORS
.SS The original VICE code by:
 Jarkko Sonninen   (sonninen@lut.fi)
 Jouko Valta       (jopi@stekt.oulu.fi)
 Teemu Rantanen    (tvr@cs.hut.fi)
 Ettore Perazzoli  (ettore@comm2000.it)
 Andre Fachat      (a.fachat@physik.tu-chemnitz.de)
.SS Development and bug fixes by:
 Vesa-Matti Puro   (vmp@lut.fi)
 Hannu Helminen    (dm@stekt.oulu.fi)
 Richard Hable     (Richard.Hable@jk.uni-linz.ac.at)
 Frank Prindle     (Frank.Prindle@lambada.oit.unc.edu)
 Peter Weighill    (stuce@csv.warwick.ac.uk)
 Marko Makela      (msmakela@nic.funet.fi)
 Dan Miner         (dminer@nyx.cs.du.edu)
 Germano Caronni   (caronni@tik.ethz.ch)
 Dominique Strigl  (strigl@sxb.bsf.alcatel.fr)
 Craig Jackson     (Craig.Jackson@lambada.oit.unc.edu)
 Ulmer Lionel      (ulmer@poly.polytechnique.fr)
 Lasse Jyrkinen    (Lasse.Jyrkinen@uz.kuleuven.ac.be)
 Daniel Fandrich   (dan@fch.wimsey.bc.ca)
 Olaf Seibert      (rhialto@mbfys.kun.nl)
 Heiko Selber      (selber@fhi-berlin.mpg.de)
