/*
 * $Id: cpm.h,v 1.1 1996/04/01 08:25:07 jopi Exp jopi $
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice
 *
 * This file contains the CP/M constants and such.
 *
 * Included are:
 *	o CP/M memory banking
 *	o Z80 register aliases
 *
 *
 * Written by
 *   Jouko Valta (jopi@stekt.oulu.fi)
 *
 *
 * $Log: cpm.h,v $
 * Revision 1.1  1996/04/01  08:25:07  jopi
 * Initial revision
 *
 *
 *
 */


#ifndef X64_CPM_H
#define X64_CPM_H


#include "config.h"
#include "types.h"
#include "file.h"


typedef unsigned short	WORD;
typedef signed char	OFFSET;


#define BIOSROM_SIZE		0x1000

#define BIOS_CHECKSUM		0


/*
 * Variables
 */

extern BYTE  *bios_rom;   /* Z80 BIOS for CP/M */



/*
 * Functions
 */

extern int  InitZ80 ( void );
extern WORD Z80 ( void /*register WORD *Addr*/ );


#endif  /* X64_CPM_H */
