/*
 * $Id: crtc.h,v 1.2 1996/07/29 20:55:42 ettore Exp ettore $
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 *
 * See README files for copyright notice.
 *
 * Header file for CRTC chip emulation.
 *
 * Written by
 *   Ettore Perazzoli (ettore@comm2000.it)
 *
 *
 * $Log: crtc.h,v $
 * Revision 1.2  1996/07/29 20:55:42  ettore
 * *** empty log message ***
 *
 * Revision 1.1  1996/04/01 06:06:46  ettore
 * Initial revision
 *
 */

#if !defined ( _CRTC_H)

#define _CRTC_H

#define BYTES_PER_CHAR 8

#define NEEDS_NormalGetTextData
#define NEEDS_NormalGetColorData
#define NEEDS_NormalGetBgDataFromRegister

#include "raster.h"

/* CHECK THESE OUT! */

#if defined (_CRTC_C)
#define BORD_HEIGHT    10
#define BORD_WIDTH     10
#define SCR_COLS      661	/* full overscan x size */
#endif

#define CRTC_NUMSPRITES 0

/* color definitions */

#define CRTC_NUMCOLORS 2

#if defined (_CRTC_C)
static char *crtc_cnames[] =
{
  "#000000",
  "#00ff00"			/* oldstyle green monitor ;) */
};
#endif

/* video mode definitions */

#define CRTC_NORMAL_MODE             0
#define CRTC_MULTICOLOR_MODE         1

void Crtc_SetVModes (void);
Window Crtc_Init (Display * disp, int scr_num, char *win_name, char *icon_name, char *res_class,
		  char *res_name, int *w, int *h, char *icon_data[], Colormap * cmap_return,
		  int exact_speed, int asleep, int refrate, Atom * wm_delwin);
void Crtc_ArrangeWindow (int width, int height);
void Crtc_Free (void);
void Crtc_Restart (void);
void Crtc_Pause (void);
void DoRaster (void);
void InitScrImg (void);

#endif /* _CRTC_H */
