/*
 * $Id: interrupt.h,v 1.2 1996/07/29 21:14:16 ettore Exp ettore $
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice
 *
 * Written by
 *   Andre Fachat     (a.fachat@physik.tu-chemnitz.de)
 *
 * $Log: interrupt.h,v $
 * Revision 1.2  1996/07/29 21:14:16  ettore
 * setalarmclk().
 * cpu_do_nmi() prototype.
 * RESET_CYCLES, NMI_CYCLES and IRQ_CYCLES for correct timing.
 *
 * Revision 1.1  1996/04/21 10:29:47  fachat
 * Initial revision
 *
 *
 * 1996/04/16 a.fachat
 * ripped from extern.h and proto.h to allow easy interrupt function calling
 * control
 *
 */

#ifndef INTERRUPT_H_
#define INTERRUPT_H_


/* Timer */

extern CLOCK  int_clk[];

extern CLOCK  next_int_clk;
extern CLOCK  cpu_tmp_clk;
extern int    next_int;

extern int cpu_check_irq;
/*extern int cpu_check_int;*/

/*#define	find_next_int()			next_int_clk=0*/
/*#define	find_next_int()			cpu_check_int=1*/
#define		find_next_int()			cpu_find_next_int()

extern ADDRESS intr ( int sig, ADDRESS pc );
extern void cpu_find_next_int ( void );
extern void jump_to_next_alarm ( void );
extern void restore ( void );

/*
extern void setalarm ( int irq, int ticks_from_now );
extern void unsetalarm ( int irq );
*/
#if 0
#define	setalarm(irq,ticks)\
	{int_clk[irq] = cpu_tmp_clk = clk + (ticks & 0x1ffff);\
	if(cpu_tmp_clk<next_int_clk) { next_int_clk = cpu_tmp_clk;\
	next_int = irq;}}
#endif

#define	setalarmclk(irq,newclk)\
	{int_clk[irq] = newclk;\
	if(newclk<next_int_clk) { next_int_clk = newclk;\
	next_int = irq;}}

#define	setalarm(irq,ticks)	{ cpu_tmp_clk = clk + ticks;\
				setalarmclk(irq,cpu_tmp_clk) }

#define	unsetalarm(irq)\
	{int_clk[irq] = 0; if(irq==next_int) find_next_int();}
	
extern void setirq ( int irq, int val );
extern ADDRESS cpu_do_int( ADDRESS );
extern void cpu_do_nmi( void );                /* start NMI routine */


#define RESET_CYCLES    6
#define NMI_CYCLES	7
#define IRQ_CYCLES	7

#endif  /* INTERRUPT_H_ */

