
/* ophack.c
 * This file is generated from op.c -do not edit.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#include "op.h"
#include "macro.h"
#include "vmachine.h"
#include "extern.h"

void brki_00 () {
    PC++;
	       /* Force break. */

#ifdef DEBUG
    if (verflg) {
	printf("BRK %ld\n", clk);
	show();
    }
#endif

    if (runflg) {
	--PC;
	printf("BRK\n");
	mon(PC);
	
    }
    if (trap_handler())
	PC = intr(I_BRK, PC);
    
    PC = (PC);;    clk += 7;
}

void ora_01 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 6;
}

void noop_02 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_slor_03 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = asl(src); AC = ora(src); */

#ifdef DEBUG_UNDOC
    puts ("SLOR -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x80);	/* ASL+ORA */
    src <<= 1;
    src |= AC;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(LOAD_ZERO_ADDR(p1 + XR), (src));;
    rmw_flag = 0;
    clk += 8;
}

void nop_04 () {

    PC += 2;

        clk += 3;
}

void ora_05 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 3;
}

void asl_06 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    SET_CARRY(src & 0x80);
    src <<= 1;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void u_slor_07 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = asl(src); AC = ora(src); */

#ifdef DEBUG_UNDOC
    puts ("SLOR -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x80);	/* ASL+ORA */
    src <<= 1;
    src |= AC;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void push_08 () {
    src = GET_SR();
    PC++;

    PUSH(src);
    /* First push item onto stack and then decrement SP. */
        clk += 3;
}

void ora_09 () {
    src = p1;

    PC += 2;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void asl_0a () {
    src = AC;

    rmw_flag = 1;	/* Read-Modify-Write instruction */
    PC++;

    SET_CARRY(src & 0x80);
    src <<= 1;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
    rmw_flag = 0;
    clk += 2;
}

void u_anc_0b () {
    src = (AC & p1);

    PC += 2;

#ifdef DEBUG_UNDOC
    puts ("ANC -- PC is now $%04X\n", PC);
#endif

#if 0
    src &= AC;
    SET_CARRY (src & 0x01);
    src >>= 1;
    SET_SIGN(src);
    SET_ZERO(src);
#else
    src &= AC;
    SET_ZERO(src);
    SET_SIGN(IF_CARRY() ? 1 : 0);
#endif
    
    AC = (src);;    clk += 2;
}

void nop_0c () {

    PC += 3;

        clk += 4;
}

void ora_0d () {
    src = LOAD(p2);

    PC += 3;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 4;
}

void asl_0e () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    SET_CARRY(src & 0x80);
    src <<= 1;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_slor_0f () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = asl(src); AC = ora(src); */

#ifdef DEBUG_UNDOC
    puts ("SLOR -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x80);	/* ASL+ORA */
    src <<= 1;
    src |= AC;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void bpl_10 () {
    src = p1;

    PC += 2;
	       /* Branch if sign flag is clear. */
    if (!IF_SIGN()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void ora_11 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void noop_12 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_slor_13 () {
    src = LOAD(LOAD_ZERO_ADDR(p1) + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = asl(src); AC = ora(src); */

#ifdef DEBUG_UNDOC
    puts ("SLOR -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x80);	/* ASL+ORA */
    src <<= 1;
    src |= AC;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(LOAD_ZERO_ADDR(p1) + YR, (src));;
    rmw_flag = 0;
    clk += 8;
}

void nop_14 () {

    PC += 2;

        clk += 4;
}

void ora_15 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 4;
}

void asl_16 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    SET_CARRY(src & 0x80);
    src <<= 1;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_slor_17 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = asl(src); AC = ora(src); */

#ifdef DEBUG_UNDOC
    puts ("SLOR -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x80);	/* ASL+ORA */
    src <<= 1;
    src |= AC;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void clrf_18 () {
    PC++;

    
    SET_CARRY((0));;    clk += 2;
}

void ora_19 () {
    src = LOAD(p2 + YR);

    PC += 3;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void nop_1a () {
    PC++;

        clk += 2;
}

void u_slor_1b () {
    src = LOAD(p2 + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = asl(src); AC = ora(src); */

#ifdef DEBUG_UNDOC
    puts ("SLOR -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x80);	/* ASL+ORA */
    src <<= 1;
    src |= AC;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + YR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void nop_1c () {

    PC += 3;

        clk += 4;
}

void ora_1d () {
    src = LOAD(p2 + XR);

    PC += 3;

    src |= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void asl_1e () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    SET_CARRY(src & 0x80);
    src <<= 1;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void u_slor_1f () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = asl(src); AC = ora(src); */

#ifdef DEBUG_UNDOC
    puts ("SLOR -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x80);	/* ASL+ORA */
    src <<= 1;
    src |= AC;
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void jsr_20 () {
    src = p2;

    PC += 3;
	       /* Jump to subroutine. */
    PC--;
    PUSH((PC >> 8) & 0xff);	/* Push return address onto the stack. */
    PUSH(PC & 0xff);

#ifdef DEBUG
    if (traceflg)
	print_stack(SP);
#endif

    
    PC = (src);;    clk += 6;
}

void and_21 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 6;
}

void noop_22 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_rlan_23 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = rol(src); AC = and(src); */

#ifdef DEBUG_UNDOC
    puts ("RLAN -- PC is now $%04X\n", PC);
#endif
  
    src <<= 1;
    if (IF_CARRY())	/* ROL+AND */
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;

    AC &= src;
    SET_SIGN(AC);
    SET_ZERO(AC);
    	/* rotated, not disturbed */
    STORE(LOAD_ZERO_ADDR(p1 + XR), (src));;
    rmw_flag = 0;
    clk += 8;
}

void bit_24 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    SET_SIGN(src);
    SET_OVERFLOW(0x40 & src);	/* Copy bit 6 to OVERFLOW flag. */
    SET_ZERO(src & AC);
        clk += 3;
}

void and_25 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 3;
}

void rol_26 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    src <<= 1;
    if (IF_CARRY())
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void u_rlan_27 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = rol(src); AC = and(src); */

#ifdef DEBUG_UNDOC
    puts ("RLAN -- PC is now $%04X\n", PC);
#endif
  
    src <<= 1;
    if (IF_CARRY())	/* ROL+AND */
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;

    AC &= src;
    SET_SIGN(AC);
    SET_ZERO(AC);
    	/* rotated, not disturbed */
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void plp_28 () {
    PC++;

    /* First increment stack pointer and then pull item from stack. */
    src = PULL();
    
    SET_SR((src));;    clk += 4;
}

void and_29 () {
    src = p1;

    PC += 2;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void rol_2a () {
    src = AC;

    rmw_flag = 1;	/* Read-Modify-Write instruction */
    PC++;

    src <<= 1;
    if (IF_CARRY())
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
    rmw_flag = 0;
    clk += 2;
}

void u_anc_2b () {
    src = (AC & p1);

    PC += 2;

#ifdef DEBUG_UNDOC
    puts ("ANC -- PC is now $%04X\n", PC);
#endif

#if 0
    src &= AC;
    SET_CARRY (src & 0x01);
    src >>= 1;
    SET_SIGN(src);
    SET_ZERO(src);
#else
    src &= AC;
    SET_ZERO(src);
    SET_SIGN(IF_CARRY() ? 1 : 0);
#endif
    
    AC = (src);;    clk += 2;
}

void bit_2c () {
    src = LOAD(p2);

    PC += 3;

    SET_SIGN(src);
    SET_OVERFLOW(0x40 & src);	/* Copy bit 6 to OVERFLOW flag. */
    SET_ZERO(src & AC);
        clk += 4;
}

void and_2d () {
    src = LOAD(p2);

    PC += 3;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 4;
}

void rol_2e () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    src <<= 1;
    if (IF_CARRY())
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_rlan_2f () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = rol(src); AC = and(src); */

#ifdef DEBUG_UNDOC
    puts ("RLAN -- PC is now $%04X\n", PC);
#endif
  
    src <<= 1;
    if (IF_CARRY())	/* ROL+AND */
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;

    AC &= src;
    SET_SIGN(AC);
    SET_ZERO(AC);
    	/* rotated, not disturbed */
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void bmi_30 () {
    src = p1;

    PC += 2;
	       /* Branch if sign flag is set. */
    if (IF_SIGN()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void and_31 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void noop_32 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_rlan_33 () {
    src = LOAD(LOAD_ZERO_ADDR(p1) + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = rol(src); AC = and(src); */

#ifdef DEBUG_UNDOC
    puts ("RLAN -- PC is now $%04X\n", PC);
#endif
  
    src <<= 1;
    if (IF_CARRY())	/* ROL+AND */
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;

    AC &= src;
    SET_SIGN(AC);
    SET_ZERO(AC);
    	/* rotated, not disturbed */
    STORE(LOAD_ZERO_ADDR(p1) + YR, (src));;
    rmw_flag = 0;
    clk += 8;
}

void nop_34 () {

    PC += 2;

        clk += 4;
}

void and_35 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 4;
}

void rol_36 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    src <<= 1;
    if (IF_CARRY())
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_rlan_37 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = rol(src); AC = and(src); */

#ifdef DEBUG_UNDOC
    puts ("RLAN -- PC is now $%04X\n", PC);
#endif
  
    src <<= 1;
    if (IF_CARRY())	/* ROL+AND */
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;

    AC &= src;
    SET_SIGN(AC);
    SET_ZERO(AC);
    	/* rotated, not disturbed */
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void setf_38 () {
    PC++;

    
    SET_CARRY((1));;    clk += 2;
}

void and_39 () {
    src = LOAD(p2 + YR);

    PC += 3;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void nop_3a () {
    PC++;

        clk += 2;
}

void u_rlan_3b () {
    src = LOAD(p2 + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = rol(src); AC = and(src); */

#ifdef DEBUG_UNDOC
    puts ("RLAN -- PC is now $%04X\n", PC);
#endif
  
    src <<= 1;
    if (IF_CARRY())	/* ROL+AND */
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;

    AC &= src;
    SET_SIGN(AC);
    SET_ZERO(AC);
    	/* rotated, not disturbed */
    STORE(p2 + YR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void nop_3c () {

    PC += 3;

        clk += 4;
}

void and_3d () {
    src = LOAD(p2 + XR);

    PC += 3;

    src &= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void rol_3e () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    src <<= 1;
    if (IF_CARRY())
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void u_rlan_3f () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = rol(src); AC = and(src); */

#ifdef DEBUG_UNDOC
    puts ("RLAN -- PC is now $%04X\n", PC);
#endif
  
    src <<= 1;
    if (IF_CARRY())	/* ROL+AND */
	src |= 0x1;
    SET_CARRY(src > 0xff);
    src &= 0xff;

    AC &= src;
    SET_SIGN(AC);
    SET_ZERO(AC);
    	/* rotated, not disturbed */
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void rti_40 () {
    PC++;
	       /* Return from interrupt. */
    /* Load program status and program counter from stack. */
    src = PULL();
    SET_SR(src);
    src = PULL();
    src |= (PULL() << 8);	/* Load return address from stack. */

#ifdef DEBUG
    if (traceflg)
	print_stack(SP);
#endif

    
    PC = (src);;    clk += 6;
}

void eor_41 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;    clk += 6;
}

void noop_42 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_sreo_43 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = lsr(src); AC = eor(src); */

#ifdef DEBUG_UNDOC
    puts ("SREO -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x01);	/* LSR+EOR */
    src >>= 1;
    src &= 0xff;

    AC ^= src;		/* JF */
    SET_SIGN(src);
    SET_ZERO(src);

    
    STORE(LOAD_ZERO_ADDR(p1 + XR), (src));;
    rmw_flag = 0;
    clk += 8;
}

void nop_44 () {

    PC += 2;

        clk += 3;
}

void eor_45 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;    clk += 3;
}

void lsr_46 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void u_sreo_47 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = lsr(src); AC = eor(src); */

#ifdef DEBUG_UNDOC
    puts ("SREO -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x01);	/* LSR+EOR */
    src >>= 1;
    src &= 0xff;

    AC ^= src;		/* JF */
    SET_SIGN(src);
    SET_ZERO(src);

    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void push_48 () {
    src = AC;
    PC++;

    PUSH(src);
    /* First push item onto stack and then decrement SP. */
        clk += 3;
}

void eor_49 () {
    src = p1;

    PC += 2;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;    clk += 2;
}

void lsr_4a () {
    src = AC;

    rmw_flag = 1;	/* Read-Modify-Write instruction */
    PC++;

    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
    rmw_flag = 0;
    clk += 2;
}

void lsr_4b () {
    src = (AC & p1);

    PC += 2;

    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void store_4c () {
    src = p2;

    PC += 3;

    
    PC = (src);;    clk += 3;
}

void eor_4d () {
    src = LOAD(p2);

    PC += 3;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;    clk += 4;
}

void lsr_4e () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_sreo_4f () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = lsr(src); AC = eor(src); */

#ifdef DEBUG_UNDOC
    puts ("SREO -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x01);	/* LSR+EOR */
    src >>= 1;
    src &= 0xff;

    AC ^= src;		/* JF */
    SET_SIGN(src);
    SET_ZERO(src);

    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void bvc_50 () {
    src = p1;

    PC += 2;
	       /* Branch if overflow flag is clear. */
    if (!IF_OVERFLOW()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void eor_51 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void noop_52 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_sreo_53 () {
    src = LOAD(LOAD_ZERO_ADDR(p1) + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = lsr(src); AC = eor(src); */

#ifdef DEBUG_UNDOC
    puts ("SREO -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x01);	/* LSR+EOR */
    src >>= 1;
    src &= 0xff;

    AC ^= src;		/* JF */
    SET_SIGN(src);
    SET_ZERO(src);

    
    STORE(LOAD_ZERO_ADDR(p1) + YR, (src));;
    rmw_flag = 0;
    clk += 8;
}

void nop_54 () {

    PC += 2;

        clk += 4;
}

void eor_55 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;    clk += 4;
}

void lsr_56 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_sreo_57 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = lsr(src); AC = eor(src); */

#ifdef DEBUG_UNDOC
    puts ("SREO -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x01);	/* LSR+EOR */
    src >>= 1;
    src &= 0xff;

    AC ^= src;		/* JF */
    SET_SIGN(src);
    SET_ZERO(src);

    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void clrf_58 () {
    PC++;

    
    SET_INTERRUPT((0));;    clk += 2;
}

void eor_59 () {
    src = LOAD(p2 + YR);

    PC += 3;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void nop_5a () {
    PC++;

        clk += 2;
}

void u_sreo_5b () {
    src = LOAD(p2 + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = lsr(src); AC = eor(src); */

#ifdef DEBUG_UNDOC
    puts ("SREO -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x01);	/* LSR+EOR */
    src >>= 1;
    src &= 0xff;

    AC ^= src;		/* JF */
    SET_SIGN(src);
    SET_ZERO(src);

    
    STORE(p2 + YR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void nop_5c () {

    PC += 3;

        clk += 4;
}

void eor_5d () {
    src = LOAD(p2 + XR);

    PC += 3;

    src ^= AC;
    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src & 0xff);;
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void lsr_5e () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void u_sreo_5f () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = lsr(src); AC = eor(src); */

#ifdef DEBUG_UNDOC
    puts ("SREO -- PC is now $%04X\n", PC);
#endif

    SET_CARRY(src & 0x01);	/* LSR+EOR */
    src >>= 1;
    src &= 0xff;

    AC ^= src;		/* JF */
    SET_SIGN(src);
    SET_ZERO(src);

    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void rts_60 () {
    PC++;
	       /* Return from subroutine. */
    src = PULL();
    src += ((PULL()) << 8) + 1;	/* Load return address from stack and add 1. */

#ifdef DEBUG
    if (traceflg)
	print_stack(SP);
#endif

    
    PC = (src);;    clk += 6;
}

void adc_61 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;    clk += 6;
}

void noop_62 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_rrad_63 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ror(src); AC = adc(src);
     * the real operation discovered by msmakela
     * ADC only does the BCD fixup */

#ifdef DEBUG_UNDOC
    puts ("RRAD -- PC is now $%04X\n", PC);
#endif

    temp = src >>1;	/* ROR+ADC */
    if (IF_CARRY())
	temp |= 0x80;

    SET_SIGN(temp);
    SET_ZERO(temp);			/* Set flags like ROR does */

    SET_OVERFLOW((temp ^ src) & 0x40);	/* ROR causes this ? */

    if (IF_DECIMAL()) {
        if ((src & 0x0f) > 4)		/* half of the normal */
            temp = (temp & 0xf0) | ((temp + 6) & 0xf);
        if (src > 0x4f)
            temp += 96;

	SET_CARRY(src > 0x4f);
    } else {
	SET_CARRY(src & 0x80);		/* 8502 behaviour */
    }

    
    STORE(LOAD_ZERO_ADDR(p1 + XR), ((BYTE) temp));;
    rmw_flag = 0;
    clk += 8;
}

void nop_64 () {

    PC += 2;

        clk += 3;
}

void adc_65 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;    clk += 3;
}

void ror_66 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    if (IF_CARRY())
	src |= 0x100;
    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void u_rrad_67 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ror(src); AC = adc(src);
     * the real operation discovered by msmakela
     * ADC only does the BCD fixup */

#ifdef DEBUG_UNDOC
    puts ("RRAD -- PC is now $%04X\n", PC);
#endif

    temp = src >>1;	/* ROR+ADC */
    if (IF_CARRY())
	temp |= 0x80;

    SET_SIGN(temp);
    SET_ZERO(temp);			/* Set flags like ROR does */

    SET_OVERFLOW((temp ^ src) & 0x40);	/* ROR causes this ? */

    if (IF_DECIMAL()) {
        if ((src & 0x0f) > 4)		/* half of the normal */
            temp = (temp & 0xf0) | ((temp + 6) & 0xf);
        if (src > 0x4f)
            temp += 96;

	SET_CARRY(src > 0x4f);
    } else {
	SET_CARRY(src & 0x80);		/* 8502 behaviour */
    }

    
    STORE_ZERO(p1, ((BYTE) temp));;
    rmw_flag = 0;
    clk += 5;
}

void pull_68 () {
    PC++;

    /* First increment stack pointer and then pull item from stack. */
    src = PULL();
    SET_SIGN(src);	/* Change sign and zero flag accordingly. */
    SET_ZERO(src);
    
    AC = (src);;    clk += 4;
}

void adc_69 () {
    src = p1;

    PC += 2;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;    clk += 2;
}

void ror_6a () {
    src = AC;

    rmw_flag = 1;	/* Read-Modify-Write instruction */
    PC++;

    if (IF_CARRY())
	src |= 0x100;
    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
    rmw_flag = 0;
    clk += 2;
}

void ror_6b () {
    src = (AC & p1);

    PC += 2;

    if (IF_CARRY())
	src |= 0x100;
    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void store_6c () {
    src = (LOAD(p2)) + (LOAD((p2&0xff00)+((p2+1)&0xff)) <<8);

    PC += 3;

    
    PC = (src);;    clk += 5;
}

void adc_6d () {
    src = LOAD(p2);

    PC += 3;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;    clk += 4;
}

void ror_6e () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    if (IF_CARRY())
	src |= 0x100;
    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_rrad_6f () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = ror(src); AC = adc(src);
     * the real operation discovered by msmakela
     * ADC only does the BCD fixup */

#ifdef DEBUG_UNDOC
    puts ("RRAD -- PC is now $%04X\n", PC);
#endif

    temp = src >>1;	/* ROR+ADC */
    if (IF_CARRY())
	temp |= 0x80;

    SET_SIGN(temp);
    SET_ZERO(temp);			/* Set flags like ROR does */

    SET_OVERFLOW((temp ^ src) & 0x40);	/* ROR causes this ? */

    if (IF_DECIMAL()) {
        if ((src & 0x0f) > 4)		/* half of the normal */
            temp = (temp & 0xf0) | ((temp + 6) & 0xf);
        if (src > 0x4f)
            temp += 96;

	SET_CARRY(src > 0x4f);
    } else {
	SET_CARRY(src & 0x80);		/* 8502 behaviour */
    }

    
    STORE(p2, ((BYTE) temp));;
    rmw_flag = 0;
    clk += 6;
}

void bvs_70 () {
    src = p1;

    PC += 2;
	       /* Branch if overflow flag is set. */
    if (IF_OVERFLOW()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void adc_71 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void noop_72 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_rrad_73 () {
    src = LOAD(LOAD_ZERO_ADDR(p1) + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ror(src); AC = adc(src);
     * the real operation discovered by msmakela
     * ADC only does the BCD fixup */

#ifdef DEBUG_UNDOC
    puts ("RRAD -- PC is now $%04X\n", PC);
#endif

    temp = src >>1;	/* ROR+ADC */
    if (IF_CARRY())
	temp |= 0x80;

    SET_SIGN(temp);
    SET_ZERO(temp);			/* Set flags like ROR does */

    SET_OVERFLOW((temp ^ src) & 0x40);	/* ROR causes this ? */

    if (IF_DECIMAL()) {
        if ((src & 0x0f) > 4)		/* half of the normal */
            temp = (temp & 0xf0) | ((temp + 6) & 0xf);
        if (src > 0x4f)
            temp += 96;

	SET_CARRY(src > 0x4f);
    } else {
	SET_CARRY(src & 0x80);		/* 8502 behaviour */
    }

    
    STORE(LOAD_ZERO_ADDR(p1) + YR, ((BYTE) temp));;
    rmw_flag = 0;
    clk += 8;
}

void nop_74 () {

    PC += 2;

        clk += 4;
}

void adc_75 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;    clk += 4;
}

void ror_76 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    if (IF_CARRY())
	src |= 0x100;
    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_rrad_77 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ror(src); AC = adc(src);
     * the real operation discovered by msmakela
     * ADC only does the BCD fixup */

#ifdef DEBUG_UNDOC
    puts ("RRAD -- PC is now $%04X\n", PC);
#endif

    temp = src >>1;	/* ROR+ADC */
    if (IF_CARRY())
	temp |= 0x80;

    SET_SIGN(temp);
    SET_ZERO(temp);			/* Set flags like ROR does */

    SET_OVERFLOW((temp ^ src) & 0x40);	/* ROR causes this ? */

    if (IF_DECIMAL()) {
        if ((src & 0x0f) > 4)		/* half of the normal */
            temp = (temp & 0xf0) | ((temp + 6) & 0xf);
        if (src > 0x4f)
            temp += 96;

	SET_CARRY(src > 0x4f);
    } else {
	SET_CARRY(src & 0x80);		/* 8502 behaviour */
    }

    
    STORE_ZERO(p1 + XR, ((BYTE) temp));;
    rmw_flag = 0;
    clk += 6;
}

void setf_78 () {
    PC++;

    
    SET_INTERRUPT((1));;    clk += 2;
}

void adc_79 () {
    src = LOAD(p2 + YR);

    PC += 3;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void nop_7a () {
    PC++;

        clk += 2;
}

void u_rrad_7b () {
    src = LOAD(p2 + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = ror(src); AC = adc(src);
     * the real operation discovered by msmakela
     * ADC only does the BCD fixup */

#ifdef DEBUG_UNDOC
    puts ("RRAD -- PC is now $%04X\n", PC);
#endif

    temp = src >>1;	/* ROR+ADC */
    if (IF_CARRY())
	temp |= 0x80;

    SET_SIGN(temp);
    SET_ZERO(temp);			/* Set flags like ROR does */

    SET_OVERFLOW((temp ^ src) & 0x40);	/* ROR causes this ? */

    if (IF_DECIMAL()) {
        if ((src & 0x0f) > 4)		/* half of the normal */
            temp = (temp & 0xf0) | ((temp + 6) & 0xf);
        if (src > 0x4f)
            temp += 96;

	SET_CARRY(src > 0x4f);
    } else {
	SET_CARRY(src & 0x80);		/* 8502 behaviour */
    }

    
    STORE(p2 + YR, ((BYTE) temp));;
    rmw_flag = 0;
    clk += 7;
}

void nop_7c () {

    PC += 3;

        clk += 4;
}

void adc_7d () {
    src = LOAD(p2 + XR);

    PC += 3;

    temp = src + AC + (IF_CARRY() ? 1 : 0);

    SET_ZERO(temp & 0xff);	/* This is not valid in decimal mode */

    /*
     * In decimal mode this is "correct" but not exact emulation. However,
     * the probability of different result when using undefined BCD codes is
     * less than 6%
     * Sign and Overflow are set between BCD fixup of the two digits  -MSM
     */

    if (IF_DECIMAL()) {
        if (((AC & 0xf) + (src & 0xf) + (IF_CARRY() ? 1 : 0)) > 9)
            temp += 6;

	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));

	if (temp > 0x99)
	    temp += 96;

	SET_CARRY(temp > 0x99);
    } else {
	SET_SIGN(temp);
	SET_OVERFLOW(!((AC ^ src) & 0x80) && ((AC ^ temp) & 0x80));
	SET_CARRY(temp > 0xff);
    }
    
    AC = ((BYTE) temp);;
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void ror_7e () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    if (IF_CARRY())
	src |= 0x100;
    SET_CARRY(src & 0x01);
    src >>= 1;

    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void u_rrad_7f () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = ror(src); AC = adc(src);
     * the real operation discovered by msmakela
     * ADC only does the BCD fixup */

#ifdef DEBUG_UNDOC
    puts ("RRAD -- PC is now $%04X\n", PC);
#endif

    temp = src >>1;	/* ROR+ADC */
    if (IF_CARRY())
	temp |= 0x80;

    SET_SIGN(temp);
    SET_ZERO(temp);			/* Set flags like ROR does */

    SET_OVERFLOW((temp ^ src) & 0x40);	/* ROR causes this ? */

    if (IF_DECIMAL()) {
        if ((src & 0x0f) > 4)		/* half of the normal */
            temp = (temp & 0xf0) | ((temp + 6) & 0xf);
        if (src > 0x4f)
            temp += 96;

	SET_CARRY(src > 0x4f);
    } else {
	SET_CARRY(src & 0x80);		/* 8502 behaviour */
    }

    
    STORE(p2 + XR, ((BYTE) temp));;
    rmw_flag = 0;
    clk += 7;
}

void nop_80 () {

    PC += 2;

        clk += 2;
}

void store_81 () {
    src = AC;

    PC += 2;

    
    STORE(LOAD_ZERO_ADDR(p1 + XR), (src));;    clk += 6;
}

void nop_82 () {

    PC += 2;

        clk += 2;
}

void store_83 () {
    src = (AC & XR);

    PC += 2;

    
    STORE(LOAD_ZERO_ADDR(p1 + XR), (src));;    clk += 6;
}

void store_84 () {
    src = YR;

    PC += 2;

    
    STORE_ZERO(p1, (src));;    clk += 3;
}

void store_85 () {
    src = AC;

    PC += 2;

    
    STORE_ZERO(p1, (src));;    clk += 3;
}

void store_86 () {
    src = XR;

    PC += 2;

    
    STORE_ZERO(p1, (src));;    clk += 3;
}

void store_87 () {
    src = (AC & XR);

    PC += 2;

    
    STORE_ZERO(p1, (src));;    clk += 3;
}

void dec_88 () {
    src = YR;
    PC++;

    src = (src - 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;    clk += 2;
}

void nop_89 () {

    PC += 2;

        clk += 2;
}

void load_reg_8a () {
    src = XR;
    PC++;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void load_reg_8b () {
    src = ((AC | 0xee) & XR & p1);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void store_8c () {
    src = YR;

    PC += 3;

    
    STORE(p2, (src));;    clk += 4;
}

void store_8d () {
    src = AC;

    PC += 3;

    
    STORE(p2, (src));;    clk += 4;
}

void store_8e () {
    src = XR;

    PC += 3;

    
    STORE(p2, (src));;    clk += 4;
}

void store_8f () {
    src = (AC & XR);

    PC += 3;

    
    STORE(p2, (src));;    clk += 4;
}

void bcc_90 () {
    src = p1;

    PC += 2;
	       /* Branch if carry flag is clear. */
    if (!IF_CARRY()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void store_91 () {
    src = AC;

    PC += 2;

    
    STORE(LOAD_ZERO_ADDR(p1) + YR, (src));;    clk += 6;
}

void noop_92 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void store_93 () {
    src = (AC & XR);

    PC += 2;

    
    u_stoshr(src, LOAD_ZERO_ADDR(p1), YR);;    clk += 6;
}

void store_94 () {
    src = YR;

    PC += 2;

    
    STORE_ZERO(p1 + XR, (src));;    clk += 4;
}

void store_95 () {
    src = AC;

    PC += 2;

    
    STORE_ZERO(p1 + XR, (src));;    clk += 4;
}

void store_96 () {
    src = XR;

    PC += 2;

    
    STORE_ZERO(p1 + YR, (src));;    clk += 4;
}

void store_97 () {
    src = (AC & XR);

    PC += 2;

    
    STORE_ZERO(p1 + YR, (src));;    clk += 4;
}

void load_reg_98 () {
    src = YR;
    PC++;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void store_99 () {
    src = AC;

    PC += 3;

    
    STORE(p2 + YR, (src));;    clk += 5;
}

void store_9a () {
    src = XR;
    PC++;

    
    SP = (src);;    clk += 2;
}

void store_9b () {
    src = (AC & XR);

    PC += 3;

    
    SP = src;	/* SHS */;    clk += 5;
}

void store_9c () {
    src = YR;

    PC += 3;

    
    u_stoshr(src, p2, XR);;    clk += 5;
}

void store_9d () {
    src = AC;

    PC += 3;

    
    STORE(p2 + XR, (src));;    clk += 5;
}

void store_9e () {
    src = XR;

    PC += 3;

    
    u_stoshr(src, p2, YR);;    clk += 5;
}

void store_9f () {
    src = (AC & XR);

    PC += 3;

    
    u_stoshr(src, p2, YR);;    clk += 5;
}

void load_reg_a0 () {
    src = p1;

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;    clk += 2;
}

void load_reg_a1 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 6;
}

void load_reg_a2 () {
    src = p1;

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 2;
}

void load_reg_a3 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = (src);;    clk += 6;
}

void load_reg_a4 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;    clk += 3;
}

void load_reg_a5 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 3;
}

void load_reg_a6 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 3;
}

void load_reg_a7 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = (src);;    clk += 3;
}

void load_reg_a8 () {
    src = AC;
    PC++;

    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;    clk += 2;
}

void load_reg_a9 () {
    src = p1;

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 2;
}

void load_reg_aa () {
    src = AC;
    PC++;

    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 2;
}

void load_reg_ab () {
    src = (AC & p1);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = (src);;    clk += 2;
}

void load_reg_ac () {
    src = LOAD(p2);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;    clk += 4;
}

void load_reg_ad () {
    src = LOAD(p2);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 4;
}

void load_reg_ae () {
    src = LOAD(p2);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 4;
}

void load_reg_af () {
    src = LOAD(p2);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = (src);;    clk += 4;
}

void bcs_b0 () {
    src = p1;

    PC += 2;
	       /* Branch if carry flag is set. */
    if (IF_CARRY()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void load_reg_b1 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void noop_b2 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void load_reg_b3 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void load_reg_b4 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;    clk += 4;
}

void load_reg_b5 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;    clk += 4;
}

void load_reg_b6 () {
    src = LOAD_ZERO(p1 + YR);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 4;
}

void load_reg_b7 () {
    src = LOAD_ZERO(p1 + YR);

    PC += 2;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = (src);;    clk += 4;
}

void clrf_b8 () {
    PC++;

    
    SET_OVERFLOW((0));;    clk += 2;
}

void load_reg_b9 () {
    src = LOAD(p2 + YR);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void load_reg_ba () {
    src = SP;
    PC++;

    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 2;
}

void load_reg_bb () {
    src = (SP & LOAD(p2 + YR));

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = SP = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void load_reg_bc () {
    src = LOAD(p2 + XR);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void load_reg_bd () {
    src = LOAD(p2 + XR);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = (src);;
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void load_reg_be () {
    src = LOAD(p2 + YR);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void load_reg_bf () {
    src = LOAD(p2 + YR);

    PC += 3;

    SET_SIGN(src);
    SET_ZERO(src);
    
    AC = XR = (src);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void cpy_c0 () {
    src = p1;

    PC += 2;

    src = YR - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 2;
}

void cmp_c1 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 6;
}

void nop_c2 () {

    PC += 2;

        clk += 2;
}

void u_decp_c3 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* cmp(--src & 0xff));  */

#ifdef DEBUG_UNDOC
    puts ("DECP -- PC is now $%04X\n", PC);
#endif

    src = (src - 1) & 0xff;	/* DEC+CMP */
    SET_CARRY(AC >= src);
    SET_SIGN(AC - src);
    SET_ZERO(AC != src);
    
    STORE(LOAD_ZERO_ADDR(p1 + XR), (src));;
    rmw_flag = 0;
    clk += 8;
}

void cpy_c4 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    src = YR - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 3;
}

void cmp_c5 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 3;
}

void dec_c6 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    src = (src - 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void u_decp_c7 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* cmp(--src & 0xff));  */

#ifdef DEBUG_UNDOC
    puts ("DECP -- PC is now $%04X\n", PC);
#endif

    src = (src - 1) & 0xff;	/* DEC+CMP */
    SET_CARRY(AC >= src);
    SET_SIGN(AC - src);
    SET_ZERO(AC != src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void inc_c8 () {
    src = YR;
    PC++;

    src = (src + 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    YR = (src);;    clk += 2;
}

void cmp_c9 () {
    src = p1;

    PC += 2;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 2;
}

void dec_ca () {
    src = XR;
    PC++;

    src = (src - 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 2;
}

void u_sbx_cb () {
    src = p1;

    PC += 2;

#ifdef DEBUG_UNDOC
    puts ("SBX -- PC is now $%04X\n", PC);
#endif

    src = (AC & XR) - src;	/* Carry is ignored (CMP) */
    /* Overflow flag may be affected */
    SET_CARRY(src < 0x100);

    src &= 0xff;	/* No decimal mode */
    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 2;
}

void cpy_cc () {
    src = LOAD(p2);

    PC += 3;

    src = YR - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 4;
}

void cmp_cd () {
    src = LOAD(p2);

    PC += 3;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 4;
}

void dec_ce () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    src = (src - 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_decp_cf () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* cmp(--src & 0xff));  */

#ifdef DEBUG_UNDOC
    puts ("DECP -- PC is now $%04X\n", PC);
#endif

    src = (src - 1) & 0xff;	/* DEC+CMP */
    SET_CARRY(AC >= src);
    SET_SIGN(AC - src);
    SET_ZERO(AC != src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void bne_d0 () {
    src = p1;

    PC += 2;
	       /* Branch if  zero flag is clear. */
    if (!IF_ZERO()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void cmp_d1 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
    
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void noop_d2 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_decp_d3 () {
    src = LOAD(LOAD_ZERO_ADDR(p1) + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* cmp(--src & 0xff));  */

#ifdef DEBUG_UNDOC
    puts ("DECP -- PC is now $%04X\n", PC);
#endif

    src = (src - 1) & 0xff;	/* DEC+CMP */
    SET_CARRY(AC >= src);
    SET_SIGN(AC - src);
    SET_ZERO(AC != src);
    
    STORE(LOAD_ZERO_ADDR(p1) + YR, (src));;
    rmw_flag = 0;
    clk += 8;
}

void nop_d4 () {

    PC += 2;

        clk += 4;
}

void cmp_d5 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 4;
}

void dec_d6 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    src = (src - 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_decp_d7 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* cmp(--src & 0xff));  */

#ifdef DEBUG_UNDOC
    puts ("DECP -- PC is now $%04X\n", PC);
#endif

    src = (src - 1) & 0xff;	/* DEC+CMP */
    SET_CARRY(AC >= src);
    SET_SIGN(AC - src);
    SET_ZERO(AC != src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void clrf_d8 () {
    PC++;

    
    SET_DECIMAL((0));;    clk += 2;
}

void cmp_d9 () {
    src = LOAD(p2 + YR);

    PC += 3;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
    
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void nop_da () {
    PC++;

        clk += 2;
}

void u_decp_db () {
    src = LOAD(p2 + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* cmp(--src & 0xff));  */

#ifdef DEBUG_UNDOC
    puts ("DECP -- PC is now $%04X\n", PC);
#endif

    src = (src - 1) & 0xff;	/* DEC+CMP */
    SET_CARRY(AC >= src);
    SET_SIGN(AC - src);
    SET_ZERO(AC != src);
    
    STORE(p2 + YR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void nop_dc () {

    PC += 3;

        clk += 4;
}

void cmp_dd () {
    src = LOAD(p2 + XR);

    PC += 3;

    src = AC - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
    
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void dec_de () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    src = (src - 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void u_decp_df () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* cmp(--src & 0xff));  */

#ifdef DEBUG_UNDOC
    puts ("DECP -- PC is now $%04X\n", PC);
#endif

    src = (src - 1) & 0xff;	/* DEC+CMP */
    SET_CARRY(AC >= src);
    SET_SIGN(AC - src);
    SET_ZERO(AC != src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void cpx_e0 () {
    src = p1;

    PC += 2;

    src = XR - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 2;
}

void sbc_e1 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    PC += 2;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;    clk += 6;
}

void nop_e2 () {

    PC += 2;

        clk += 2;
}

void u_isbc_e3 () {
    src = LOAD(LOAD_ZERO_ADDR(p1 + XR));

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ++src & 0xff; AC = sbc(src); */

#ifdef DEBUG_UNDOC
    puts ("ISBC -- PC is now $%04X\n", PC);
#endif

    src = ((src + 1) & 0xff);	/* INC+SBC */

    temp = AC - src - (IF_CARRY() ? 0 : 1);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
	    temp -= 6;
	if (temp > 0x99)
	    temp -= 0x60;
    }
    SET_CARRY(temp < 0x100);

    AC = temp;
    	/* src saved */
    STORE(LOAD_ZERO_ADDR(p1 + XR), (src));;
    rmw_flag = 0;
    clk += 8;
}

void cpx_e4 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    src = XR - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 3;
}

void sbc_e5 () {
    src = LOAD_ZERO(p1);

    PC += 2;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;    clk += 3;
}

void inc_e6 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    src = (src + 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void u_isbc_e7 () {
    src = LOAD_ZERO(p1);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ++src & 0xff; AC = sbc(src); */

#ifdef DEBUG_UNDOC
    puts ("ISBC -- PC is now $%04X\n", PC);
#endif

    src = ((src + 1) & 0xff);	/* INC+SBC */

    temp = AC - src - (IF_CARRY() ? 0 : 1);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
	    temp -= 6;
	if (temp > 0x99)
	    temp -= 0x60;
    }
    SET_CARRY(temp < 0x100);

    AC = temp;
    	/* src saved */
    STORE_ZERO(p1, (src));;
    rmw_flag = 0;
    clk += 5;
}

void inc_e8 () {
    src = XR;
    PC++;

    src = (src + 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    XR = (src);;    clk += 2;
}

void sbc_e9 () {
    src = p1;

    PC += 2;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;    clk += 2;
}

void nop_ea () {
    PC++;

        clk += 2;
}

void sbc_eb () {
    src = p1;

    PC += 2;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;    clk += 2;
}

void cpx_ec () {
    src = LOAD(p2);

    PC += 3;

    src = XR - src;
    SET_CARRY(src < 0x100);
    SET_SIGN(src);
    SET_ZERO(src &= 0xff);
        clk += 4;
}

void sbc_ed () {
    src = LOAD(p2);

    PC += 3;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;    clk += 4;
}

void inc_ee () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    src = (src + 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_isbc_ef () {
    src = LOAD(p2);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = ++src & 0xff; AC = sbc(src); */

#ifdef DEBUG_UNDOC
    puts ("ISBC -- PC is now $%04X\n", PC);
#endif

    src = ((src + 1) & 0xff);	/* INC+SBC */

    temp = AC - src - (IF_CARRY() ? 0 : 1);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
	    temp -= 6;
	if (temp > 0x99)
	    temp -= 0x60;
    }
    SET_CARRY(temp < 0x100);

    AC = temp;
    	/* src saved */
    STORE(p2, (src));;
    rmw_flag = 0;
    clk += 6;
}

void beq_f0 () {
    src = p1;

    PC += 2;
	       /* Branch if  zero flag is set. */
    if (IF_ZERO()) {
	clk += ((PC & 0xFF00) != (REL_ADDR(PC, src) & 0xFF00) ? 2 : 1);
	PC = REL_ADDR(PC, src);
    }
        clk += 2;
}

void sbc_f1 () {

    p2 = LOAD_ZERO_ADDR(p1);
    src = LOAD(p2 + YR);

    PC += 2;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 5;
}

void noop_f2 () {
    PC++;
	       /* No such opcode. */
    (void) printf("Illegal instruction.\n");
    verflg = 1;
    --PC;
    show();
    mon(PC);
    }

void u_isbc_f3 () {
    src = LOAD(LOAD_ZERO_ADDR(p1) + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ++src & 0xff; AC = sbc(src); */

#ifdef DEBUG_UNDOC
    puts ("ISBC -- PC is now $%04X\n", PC);
#endif

    src = ((src + 1) & 0xff);	/* INC+SBC */

    temp = AC - src - (IF_CARRY() ? 0 : 1);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
	    temp -= 6;
	if (temp > 0x99)
	    temp -= 0x60;
    }
    SET_CARRY(temp < 0x100);

    AC = temp;
    	/* src saved */
    STORE(LOAD_ZERO_ADDR(p1) + YR, (src));;
    rmw_flag = 0;
    clk += 8;
}

void nop_f4 () {

    PC += 2;

        clk += 4;
}

void sbc_f5 () {
    src = LOAD_ZERO(p1 + XR);

    PC += 2;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;    clk += 4;
}

void inc_f6 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    src = (src + 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void u_isbc_f7 () {
    src = LOAD_ZERO(p1 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 2;

    /* src = ++src & 0xff; AC = sbc(src); */

#ifdef DEBUG_UNDOC
    puts ("ISBC -- PC is now $%04X\n", PC);
#endif

    src = ((src + 1) & 0xff);	/* INC+SBC */

    temp = AC - src - (IF_CARRY() ? 0 : 1);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
	    temp -= 6;
	if (temp > 0x99)
	    temp -= 0x60;
    }
    SET_CARRY(temp < 0x100);

    AC = temp;
    	/* src saved */
    STORE_ZERO(p1 + XR, (src));;
    rmw_flag = 0;
    clk += 6;
}

void setf_f8 () {
    PC++;

    
    SET_DECIMAL((1));;    clk += 2;
}

void sbc_f9 () {
    src = LOAD(p2 + YR);

    PC += 3;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;
	if ((p2 & 0xFF) + YR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void nop_fa () {
    PC++;

        clk += 2;
}

void u_isbc_fb () {
    src = LOAD(p2 + YR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = ++src & 0xff; AC = sbc(src); */

#ifdef DEBUG_UNDOC
    puts ("ISBC -- PC is now $%04X\n", PC);
#endif

    src = ((src + 1) & 0xff);	/* INC+SBC */

    temp = AC - src - (IF_CARRY() ? 0 : 1);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
	    temp -= 6;
	if (temp > 0x99)
	    temp -= 0x60;
    }
    SET_CARRY(temp < 0x100);

    AC = temp;
    	/* src saved */
    STORE(p2 + YR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void nop_fc () {

    PC += 3;

        clk += 4;
}

void sbc_fd () {
    src = LOAD(p2 + XR);

    PC += 3;

    /*
     * SBC is not exact either. It has 6% different results too.
     */

    src ^= 0xff;
    temp = AC + src + (IF_CARRY() ? 1 : 0);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
#if 0
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
#endif
	if ((temp & 0xf) > 0x9)
	    temp -= 6;
	if ((temp & 0xf0) > 0x90)
	    temp -= 0x60;
    }
    SET_CARRY(temp >= 0x100);
    
    AC = (temp & 0xff);;
	if ((p2 & 0xFF) + XR > 0x100)	/* PBC */
		++clk;
    clk += 4;
}

void inc_fe () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    src = (src + 1) & 0xff;
    SET_SIGN(src);
    SET_ZERO(src);
    
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}

void u_isbc_ff () {
    src = LOAD(p2 + XR);

    rmw_flag = 1;	/* Read-Modify-Write instruction */

    PC += 3;

    /* src = ++src & 0xff; AC = sbc(src); */

#ifdef DEBUG_UNDOC
    puts ("ISBC -- PC is now $%04X\n", PC);
#endif

    src = ((src + 1) & 0xff);	/* INC+SBC */

    temp = AC - src - (IF_CARRY() ? 0 : 1);

    SET_SIGN(temp);
    SET_ZERO(temp & 0xff);	/* Sign and Zero are invalid in decimal mode */

    SET_OVERFLOW(((AC ^ temp) & 0x80) && ((AC ^ src) & 0x80));

    if (IF_DECIMAL()) {
	if ( ((AC & 0xf) - (IF_CARRY() ? 0 : 1)) < (src & 0xf))	/* EP */
	    temp -= 6;
	if (temp > 0x99)
	    temp -= 0x60;
    }
    SET_CARRY(temp < 0x100);

    AC = temp;
    	/* src saved */
    STORE(p2 + XR, (src));;
    rmw_flag = 0;
    clk += 7;
}


