/* $Id: sid.h,v 1.1 1996/07/29 22:49:04 ettore Exp ettore $
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice.
 *
 * SID 6581 interfacing.
 *
 *
 * Written by
 *   Lionel Ulmer        (ulmer@cs.brandeis.edu)
 *
 *
 * $Log: sid.h,v $
 * Revision 1.1  1996/07/29 22:49:04  ettore
 * Initial revision
 *
 */


#ifndef _SID_H
#define _SID_H

#include "types.h"

#ifdef _SID_C
BYTE sid[32];
CLOCK sid_clk;
#else
extern BYTE sid[32];
extern CLOCK sid_clk;
#endif

#define SIDCLK 1.023e6

#define PWHI 0x0F

#define GATE 0x01
#define SYNC 0x02
#define RING 0x04
#define TEST 0x08
#define TRIA 0x10
#define SAWT 0x20
#define PULS 0x40
#define NOIS 0x80

#define ATK  0xF0
#define DCY  0x0F
#define STN  0xF0
#define RLS  0x0F

void store_sid (ADDRESS address, BYTE byte);
BYTE read_sid (ADDRESS address);
void SIDemu(int) ;
void IniSID(void) ;

#endif /* !defined (_SID_H) */
