
/* tablehack.c
 * This file is generated from table.c -do not edit.
 */

#include "cpu.h"
#include "mnemonic.h"
#include "ophack.h"

/*
 * $Id: table.c,v 1.10 1996/07/29 22:57:17 ettore Exp ettore $
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice
 *
 * This file contains lookup-table which is used to translate
 * MOS6502 machine instructions. Machine code is used as index
 * to array called lookup. Pointer to function is then fetched
 * from array and function is called.
 * Timing of the undocumented opcodes is based on information
 * in an article in C=Lehti by Kai Lindfors and Topi Maurola.
 *
 *
 * Written by
 *   Vesa-Matti Puro (vmp@lut.fi)
 *   Jarkko Sonninen (sonninen@lut.fi)
 *   Jouko Valta (jopi@stekt.oulu.fi)
 *
 *
 * $Log: table.c,v $
 * Revision 1.10  1996/07/29 22:57:17  ettore
 * lookup[] changed to provide a separate u_anc() function for the
 * ANC illegal opcode.
 *
 * Revision 1.9  1996/04/01  09:01:41  jopi
 * *** empty log message ***
 *
 * Revision 1.8  1995/04/01  07:54:09  jopi
 * X64 0.3 PL 0
 * Some inconsistency removed.
 *
 * Revision 1.7  1994/12/12  16:59:44  jopi
 * Added clock fix flag
 *
 * Revision 1.6  1994/08/10  17:52:03  jopi
 * *** empty log message ***
 *
 * Revision 1.5  1994/06/16  17:19:26  jopi
 * Code reorganized and cleaned up
 *
 * Revision 1.4  1993/11/10  01:55:34  jopi
 * reu, asm and disk directory fixed
 * REL_ADDR macro and 1541 made more portable
 *
 * Revision 1.3  93/06/21  13:39:31  jopi
 *  X64 version 0.2 PL 0
 *
 * Revision 1.2  1993/06/13  08:21:50  sonninen
 * *** empty log message ***
 *
 */
/*
 * The "mnemonic.h" file contains #defines for BRK, ORA, NOOP... which
 * are character strings, i.e. #define BRK    "BRK"
 * #define ORA    "ORA" . . . Used mainly to reduce typing...
 *
 * There are #defines for addressing modes i.e. IMPLIED, INDIRECT_X,
 * ZERO_PAGE in "cpu.h"... These can be used to make a diassembler.
 */
int     clength[] = {1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 2, 2, 2, 0};
struct lookup_tag lookup[] = {
    /****  Positive  ****/
   { brki_00,	BRK,	IMPLIED,	M_NONE,	M_PC,	7,	0 },
   { ora_01,	ORA,	INDIRECT_X,	M_INDX,	M_AC,	6,	0 },
   { noop_02,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_slor_03,	SLO,	INDIRECT_X,	M_INDX,	M_INDX,	8,	0 },
   { nop_04,	NOOP,	ZERO_PAGE,	M_NONE,	M_NONE,	3,	0 },
   { ora_05,	ORA,	ZERO_PAGE,	M_ZERO,	M_AC,	3,	0 },
   { asl_06,	ASL,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { u_slor_07,	SLO,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { push_08,	PHP,	IMPLIED,	M_SR,	M_NONE,	3,	0 },
   { ora_09,	ORA,	IMMEDIATE,	M_IMM,	M_AC,	2,	0 },
   { asl_0a,	ASL,	ACCUMULATOR,	M_AC,	M_AC,	2,	0 },
   { u_anc_0b,	ANC,	IMMEDIATE,	M_ACIM,	M_ACNC,	2,	0 },
   { nop_0c,	NOOP,	ABSOLUTE,	M_NONE,	M_NONE,	4,	0 },
   { ora_0d,	ORA,	ABSOLUTE,	M_ABS,	M_AC,	4,	0 },
   { asl_0e,	ASL,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { u_slor_0f,	SLO,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { bpl_10,	BPL,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { ora_11,	ORA,	INDIRECT_Y,	M_INDY,	M_AC,	5,	1 },
   { noop_12,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_slor_13,	SLO,	INDIRECT_Y,	M_INDY,	M_INDY,	8,	0 },
   { nop_14,	NOOP,	ZERO_PAGE_X,	M_NONE,	M_NONE,	4,	0 },
   { ora_15,	ORA,	ZERO_PAGE_X,	M_ZERX,	M_AC,	4,	0 },
   { asl_16,	ASL,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { u_slor_17,	SLO,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { clrf_18,	CLC,	IMPLIED,	M_NONE,	M_FC,	2,	0 },
   { ora_19,	ORA,	ABSOLUTE_Y,	M_ABSY,	M_AC,	4,	1 },
   { nop_1a,	NOOP,	IMPLIED,	M_NONE,	M_NONE,	2,	0 },
   { u_slor_1b,	SLO,	ABSOLUTE_Y,	M_ABSY,	M_ABSY,	7,	0 },
   { nop_1c,	NOOP,	ABSOLUTE_X,	M_NONE,	M_NONE,	4,	1 },
   { ora_1d,	ORA,	ABSOLUTE_X,	M_ABSX,	M_AC,	4,	1 },
   { asl_1e,	ASL,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { u_slor_1f,	SLO,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { jsr_20,	JSR,	ABSOLUTE,	M_ADDR,	M_PC,	6,	0 },
   { and_21,	AND,	INDIRECT_X,	M_INDX,	M_AC,	6,	0 },
   { noop_22,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_rlan_23,	RLA,	INDIRECT_X,	M_INDX,	M_INDX,	8,	0 },
   { bit_24,	BIT,	ZERO_PAGE,	M_ZERO,	M_NONE,	3,	0 },
   { and_25,	AND,	ZERO_PAGE,	M_ZERO,	M_AC,	3,	0 },
   { rol_26,	ROL,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { u_rlan_27,	RLA,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { plp_28,	PLP,	IMPLIED,	M_NONE,	M_SR,	4,	0 },
   { and_29,	AND,	IMMEDIATE,	M_IMM,	M_AC,	2,	0 },
   { rol_2a,	ROL,	ACCUMULATOR,	M_AC,	M_AC,	2,	0 },
   { u_anc_2b,	ANC,	IMMEDIATE,	M_ACIM,	M_ACNC,	2,	0 },
   { bit_2c,	BIT,	ABSOLUTE,	M_ABS,	M_NONE,	4,	0 },
   { and_2d,	AND,	ABSOLUTE,	M_ABS,	M_AC,	4,	0 },
   { rol_2e,	ROL,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { u_rlan_2f,	RLA,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { bmi_30,	BMI,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { and_31,	AND,	INDIRECT_Y,	M_INDY,	M_AC,	5,	1 },
   { noop_32,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_rlan_33,	RLA,	INDIRECT_Y,	M_INDY,	M_INDY,	8,	0 },
   { nop_34,	NOOP,	ZERO_PAGE_X,	M_NONE,	M_NONE,	4,	0 },
   { and_35,	AND,	ZERO_PAGE_X,	M_ZERX,	M_AC,	4,	0 },
   { rol_36,	ROL,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { u_rlan_37,	RLA,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { setf_38,	SEC,	IMPLIED,	M_NONE,	M_FC,	2,	0 },
   { and_39,	AND,	ABSOLUTE_Y,	M_ABSY,	M_AC,	4,	1 },
   { nop_3a,	NOOP,	IMPLIED,	M_NONE,	M_NONE,	2,	0 },
   { u_rlan_3b,	RLA,	ABSOLUTE_Y,	M_ABSY,	M_ABSY,	7,	0 },
   { nop_3c,	NOOP,	ABSOLUTE_X,	M_NONE,	M_NONE,	4,	1 },
   { and_3d,	AND,	ABSOLUTE_X,	M_ABSX,	M_AC,	4,	1 },
   { rol_3e,	ROL,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { u_rlan_3f,	RLA,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { rti_40,	RTI,	IMPLIED,	M_NONE,	M_PC,	6,	0 },
   { eor_41,	EOR,	INDIRECT_X,	M_INDX,	M_AC,	6,	0 },
   { noop_42,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_sreo_43,	SRE,	INDIRECT_X,	M_INDX,	M_INDX,	8,	0 },
   { nop_44,	NOOP,	ZERO_PAGE,	M_NONE,	M_NONE,	3,	0 },
   { eor_45,	EOR,	ZERO_PAGE,	M_ZERO,	M_AC,	3,	0 },
   { lsr_46,	LSR,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { u_sreo_47,	SRE,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { push_48,	PHA,	IMPLIED,	M_AC,	M_NONE,	3,	0 },
   { eor_49,	EOR,	IMMEDIATE,	M_IMM,	M_AC,	2,	0 },
   { lsr_4a,	LSR,	ACCUMULATOR,	M_AC,	M_AC,	2,	0 },
   { lsr_4b,	ASR,	IMMEDIATE,	M_ACIM,	M_AC,	2,	0 },
   { store_4c,	JMP,	ABSOLUTE,	M_ADDR,	M_PC,	3,	0 },
   { eor_4d,	EOR,	ABSOLUTE,	M_ABS,	M_AC,	4,	0 },
   { lsr_4e,	LSR,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { u_sreo_4f,	SRE,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { bvc_50,	BVC,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { eor_51,	EOR,	INDIRECT_Y,	M_INDY,	M_AC,	5,	1 },
   { noop_52,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_sreo_53,	SRE,	INDIRECT_Y,	M_INDY,	M_INDY,	8,	0 },
   { nop_54,	NOOP,	ZERO_PAGE_X,	M_NONE,	M_NONE,	4,	0 },
   { eor_55,	EOR,	ZERO_PAGE_X,	M_ZERX,	M_AC,	4,	0 },
   { lsr_56,	LSR,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { u_sreo_57,	SRE,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { clrf_58,	CLI,	IMPLIED,	M_NONE,	M_FI,	2,	0 },
   { eor_59,	EOR,	ABSOLUTE_Y,	M_ABSY,	M_AC,	4,	1 },
   { nop_5a,	NOOP,	IMPLIED,	M_NONE,	M_NONE,	2,	0 },
   { u_sreo_5b,	SRE,	ABSOLUTE_Y,	M_ABSY,	M_ABSY,	7,	0 },
   { nop_5c,	NOOP,	ABSOLUTE_X,	M_NONE,	M_NONE,	4,	1 },
   { eor_5d,	EOR,	ABSOLUTE_X,	M_ABSX,	M_AC,	4,	1 },
   { lsr_5e,	LSR,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { u_sreo_5f,	SRE,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { rts_60,	RTS,	IMPLIED,	M_NONE,	M_PC,	6,	0 },
   { adc_61,	ADC,	INDIRECT_X,	M_INDX,	M_AC,	6,	0 },
   { noop_62,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_rrad_63,	RRA,	INDIRECT_X,	M_INDX,	M_INDX,	8,	0 },
   { nop_64,	NOOP,	ZERO_PAGE,	M_NONE,	M_NONE,	3,	0 },
   { adc_65,	ADC,	ZERO_PAGE,	M_ZERO,	M_AC,	3,	0 },
   { ror_66,	ROR,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { u_rrad_67,	RRA,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { pull_68,	PLA,	IMPLIED,	M_NONE,	M_AC,	4,	0 },
   { adc_69,	ADC,	IMMEDIATE,	M_IMM,	M_AC,	2,	0 },
   { ror_6a,	ROR,	ACCUMULATOR,	M_AC,	M_AC,	2,	0 },
   { ror_6b,	ARR,	IMMEDIATE,	M_ACIM,	M_AC,	2,	0 },
   { store_6c,	JMP,	ABS_INDIRECT,	M_AIND,	M_PC,	5,	0 },
   { adc_6d,	ADC,	ABSOLUTE,	M_ABS,	M_AC,	4,	0 },
   { ror_6e,	ROR,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { u_rrad_6f,	RRA,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { bvs_70,	BVS,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { adc_71,	ADC,	INDIRECT_Y,	M_INDY,	M_AC,	5,	1 },
   { noop_72,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_rrad_73,	RRA,	INDIRECT_Y,	M_INDY,	M_INDY,	8,	0 },
   { nop_74,	NOOP,	ZERO_PAGE_X,	M_NONE,	M_NONE,	4,	0 },
   { adc_75,	ADC,	ZERO_PAGE_X,	M_ZERX,	M_AC,	4,	0 },
   { ror_76,	ROR,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { u_rrad_77,	RRA,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { setf_78,	SEI,	IMPLIED,	M_NONE,	M_FI,	2,	0 },
   { adc_79,	ADC,	ABSOLUTE_Y,	M_ABSY,	M_AC,	4,	1 },
   { nop_7a,	NOOP,	IMPLIED,	M_NONE,	M_NONE,	2,	0 },
   { u_rrad_7b,	RRA,	ABSOLUTE_Y,	M_ABSY,	M_ABSY,	7,	0 },
   { nop_7c,	NOOP,	ABSOLUTE_X,	M_NONE,	M_NONE,	4,	1 },
   { adc_7d,	ADC,	ABSOLUTE_X,	M_ABSX,	M_AC,	4,	1 },
   { ror_7e,	ROR,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { u_rrad_7f,	RRA,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
    /****  Negative  ****/
   { nop_80,	NOOP,	IMMEDIATE,	M_NONE,	M_NONE,	2,	0 },
   { store_81,	STA,	INDIRECT_X,	M_AC,	M_INDX,	6,	0 },
   { nop_82,	NOOP,	IMMEDIATE,	M_NONE,	M_NONE,	2,	0 },
   { store_83,	SAX,	INDIRECT_X,	M_ANXR,	M_INDX,	6,	0 },
   { store_84,	STY,	ZERO_PAGE,	M_YR,	M_ZERO,	3,	0 },
   { store_85,	STA,	ZERO_PAGE,	M_AC,	M_ZERO,	3,	0 },
   { store_86,	STX,	ZERO_PAGE,	M_XR,	M_ZERO,	3,	0 },
   { store_87,	SAX,	ZERO_PAGE,	M_ANXR,	M_ZERO,	3,	0 },
   { dec_88,	DEY,	IMPLIED,	M_YR,	M_YR,	2,	0 },
   { nop_89,	NOOP,	IMMEDIATE,	M_NONE,	M_NONE,	2,	0 },
   { load_reg_8a,	TXA,	IMPLIED,	M_XR,	M_AC,	2,	0 },
    /****  very abnormal: usually AC = AC | #$EE & XR & #$oper  ****/
   { load_reg_8b,	ANE,	IMMEDIATE,	M_AXIM,	M_AC,	2,	0 },
   { store_8c,	STY,	ABSOLUTE,	M_YR,	M_ABS,	4,	0 },
   { store_8d,	STA,	ABSOLUTE,	M_AC,	M_ABS,	4,	0 },
   { store_8e,	STX,	ABSOLUTE,	M_XR,	M_ABS,	4,	0 },
   { store_8f,	SAX,	ABSOLUTE,	M_ANXR,	M_ABS,	4,	0 },
   { bcc_90,	BCC,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { store_91,	STA,	INDIRECT_Y,	M_AC,	M_INDY,	6,	0 },
   { noop_92,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { store_93,	SHA,	INDIRECT_Y,	M_ANXR,	M_STH0,	6,	0 },
   { store_94,	STY,	ZERO_PAGE_X,	M_YR,	M_ZERX,	4,	0 },
   { store_95,	STA,	ZERO_PAGE_X,	M_AC,	M_ZERX,	4,	0 },
   { store_96,	STX,	ZERO_PAGE_Y,	M_XR,	M_ZERY,	4,	0 },
   { store_97,	SAX,	ZERO_PAGE_Y,	M_ANXR,	M_ZERY,	4,	0 },
   { load_reg_98,	TYA,	IMPLIED,	M_YR,	M_AC,	2,	0 },
   { store_99,	STA,	ABSOLUTE_Y,	M_AC,	M_ABSY,	5,	0 },
   { store_9a,	TXS,	IMPLIED,	M_XR,	M_SP,	2,	0 },
    /*** This is very mysterious command ... */
   { store_9b,	SHS,	ABSOLUTE_Y,	M_ANXR,	M_STH3,	5,	0 },
   { store_9c,	SHY,	ABSOLUTE_X,	M_YR,	M_STH2,	5,	0 },
   { store_9d,	STA,	ABSOLUTE_X,	M_AC,	M_ABSX,	5,	0 },
   { store_9e,	SHX,	ABSOLUTE_Y,	M_XR,	M_STH1,	5,	0 },
   { store_9f,	SHA,	ABSOLUTE_Y,	M_ANXR,	M_STH1,	5,	0 },
   { load_reg_a0,	LDY,	IMMEDIATE,	M_IMM,	M_YR,	2,	0 },
   { load_reg_a1,	LDA,	INDIRECT_X,	M_INDX,	M_AC,	6,	0 },
   { load_reg_a2,	LDX,	IMMEDIATE,	M_IMM,	M_XR,	2,	0 },
   { load_reg_a3,	LAX,	INDIRECT_X,	M_INDX,	M_ACXR,	6,	0 },
   { load_reg_a4,	LDY,	ZERO_PAGE,	M_ZERO,	M_YR,	3,	0 },
   { load_reg_a5,	LDA,	ZERO_PAGE,	M_ZERO,	M_AC,	3,	0 },
   { load_reg_a6,	LDX,	ZERO_PAGE,	M_ZERO,	M_XR,	3,	0 },
   { load_reg_a7,	LAX,	ZERO_PAGE,	M_ZERO,	M_ACXR,	3,	0 },
   { load_reg_a8,	TAY,	IMPLIED,	M_AC,	M_YR,	2,	0 },
   { load_reg_a9,	LDA,	IMMEDIATE,	M_IMM,	M_AC,	2,	0 },
   { load_reg_aa,	TAX,	IMPLIED,	M_AC,	M_XR,	2,	0 },
   { load_reg_ab,	LXA,	IMMEDIATE,	M_ACIM,	M_ACXR,	2,	0 },
   { load_reg_ac,	LDY,	ABSOLUTE,	M_ABS,	M_YR,	4,	0 },
   { load_reg_ad,	LDA,	ABSOLUTE,	M_ABS,	M_AC,	4,	0 },
   { load_reg_ae,	LDX,	ABSOLUTE,	M_ABS,	M_XR,	4,	0 },
   { load_reg_af,	LAX,	ABSOLUTE,	M_ABS,	M_ACXR,	4,	0 },
   { bcs_b0,	BCS,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { load_reg_b1,	LDA,	INDIRECT_Y,	M_INDY,	M_AC,	5,	1 },
   { noop_b2,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { load_reg_b3,	LAX,	INDIRECT_Y,	M_INDY,	M_ACXR,	5,	1 },
   { load_reg_b4,	LDY,	ZERO_PAGE_X,	M_ZERX,	M_YR,	4,	0 },
   { load_reg_b5,	LDA,	ZERO_PAGE_X,	M_ZERX,	M_AC,	4,	0 },
   { load_reg_b6,	LDX,	ZERO_PAGE_Y,	M_ZERY,	M_XR,	4,	0 },
   { load_reg_b7,	LAX,	ZERO_PAGE_Y,	M_ZERY,	M_ACXR,	4,	0 },
   { clrf_b8,	CLV,	IMPLIED,	M_NONE,	M_FV,	2,	0 },
   { load_reg_b9,	LDA,	ABSOLUTE_Y,	M_ABSY,	M_AC,	4,	1 },
   { load_reg_ba,	TSX,	IMPLIED,	M_SP,	M_XR,	2,	0 },
   { load_reg_bb,	LAS,	ABSOLUTE_Y,	M_SABY,	M_ACXS,	4,	1 },
   { load_reg_bc,	LDY,	ABSOLUTE_X,	M_ABSX,	M_YR,	4,	1 },
   { load_reg_bd,	LDA,	ABSOLUTE_X,	M_ABSX,	M_AC,	4,	1 },
   { load_reg_be,	LDX,	ABSOLUTE_Y,	M_ABSY,	M_XR,	4,	1 },
   { load_reg_bf,	LAX,	ABSOLUTE_Y,	M_ABSY,	M_ACXR,	4,	1 },
   { cpy_c0,	CPY,	IMMEDIATE,	M_IMM,	M_NONE,	2,	0 },
   { cmp_c1,	CMP,	INDIRECT_X,	M_INDX,	M_NONE,	6,	0 },
   { nop_c2,	NOOP,	IMMEDIATE,	M_NONE,	M_NONE,	2,	0 },
   { u_decp_c3,	DCP,	INDIRECT_X,	M_INDX,	M_INDX,	8,	0 },
   { cpy_c4,	CPY,	ZERO_PAGE,	M_ZERO,	M_NONE,	3,	0 },
   { cmp_c5,	CMP,	ZERO_PAGE,	M_ZERO,	M_NONE,	3,	0 },
   { dec_c6,	DEC,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { u_decp_c7,	DCP,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { inc_c8,	INY,	IMPLIED,	M_YR,	M_YR,	2,	0 },
   { cmp_c9,	CMP,	IMMEDIATE,	M_IMM,	M_NONE,	2,	0 },
   { dec_ca,	DEX,	IMPLIED,	M_XR,	M_XR,	2,	0 },
   { u_sbx_cb,	SBX,	IMMEDIATE,	M_IMM,	M_XR,	2,	0 },
   { cpy_cc,	CPY,	ABSOLUTE,	M_ABS,	M_NONE,	4,	0 },
   { cmp_cd,	CMP,	ABSOLUTE,	M_ABS,	M_NONE,	4,	0 },
   { dec_ce,	DEC,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { u_decp_cf,	DCP,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { bne_d0,	BNE,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { cmp_d1,	CMP,	INDIRECT_Y,	M_INDY,	M_NONE,	5,	1 },
   { noop_d2,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_decp_d3,	DCP,	INDIRECT_Y,	M_INDY,	M_INDY,	8,	0 },
   { nop_d4,	NOOP,	ZERO_PAGE_X,	M_NONE,	M_NONE,	4,	0 },
   { cmp_d5,	CMP,	ZERO_PAGE_X,	M_ZERX,	M_NONE,	4,	0 },
   { dec_d6,	DEC,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { u_decp_d7,	DCP,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { clrf_d8,	CLD,	IMPLIED,	M_NONE,	M_FD,	2,	0 },
   { cmp_d9,	CMP,	ABSOLUTE_Y,	M_ABSY,	M_NONE,	4,	1 },
   { nop_da,	NOOP,	IMPLIED,	M_NONE,	M_NONE,	2,	0 },
   { u_decp_db,	DCP,	ABSOLUTE_Y,	M_ABSY,	M_ABSY,	7,	0 },
   { nop_dc,	NOOP,	ABSOLUTE_X,	M_NONE,	M_NONE,	4,	1 },
   { cmp_dd,	CMP,	ABSOLUTE_X,	M_ABSX,	M_NONE,	4,	1 },
   { dec_de,	DEC,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { u_decp_df,	DCP,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { cpx_e0,	CPX,	IMMEDIATE,	M_IMM,	M_NONE,	2,	0 },
   { sbc_e1,	SBC,	INDIRECT_X,	M_INDX,	M_AC,	6,	0 },
   { nop_e2,	NOOP,	IMMEDIATE,	M_NONE,	M_NONE,	2,	0 },
   { u_isbc_e3,	ISB,	INDIRECT_X,	M_INDX,	M_INDX,	8,	0 },
   { cpx_e4,	CPX,	ZERO_PAGE,	M_ZERO,	M_NONE,	3,	0 },
   { sbc_e5,	SBC,	ZERO_PAGE,	M_ZERO,	M_AC,	3,	0 },
   { inc_e6,	INC,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { u_isbc_e7,	ISB,	ZERO_PAGE,	M_ZERO,	M_ZERO,	5,	0 },
   { inc_e8,	INX,	IMPLIED,	M_XR,	M_XR,	2,	0 },
   { sbc_e9,	SBC,	IMMEDIATE,	M_IMM,	M_AC,	2,	0 },
   { nop_ea,	NOP,	IMPLIED,	M_NONE,	M_NONE,	2,	0 },
   { sbc_eb,	USBC,	IMMEDIATE,	M_IMM,	M_AC,	2,	0 },
   { cpx_ec,	CPX,	ABSOLUTE,	M_ABS,	M_NONE,	4,	0 },
   { sbc_ed,	SBC,	ABSOLUTE,	M_ABS,	M_AC,	4,	0 },
   { inc_ee,	INC,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { u_isbc_ef,	ISB,	ABSOLUTE,	M_ABS,	M_ABS,	6,	0 },
   { beq_f0,	BEQ,	RELATIVE,	M_REL,	M_NONE,	2,	0 },
   { sbc_f1,	SBC,	INDIRECT_Y,	M_INDY,	M_AC,	5,	1 },
   { noop_f2,	JAM,	IMPLIED,	M_NONE,	M_NONE,	0,	0 },
   { u_isbc_f3,	ISB,	INDIRECT_Y,	M_INDY,	M_INDY,	8,	0 },
   { nop_f4,	NOOP,	ZERO_PAGE_X,	M_NONE,	M_NONE,	4,	0 },
   { sbc_f5,	SBC,	ZERO_PAGE_X,	M_ZERX,	M_AC,	4,	0 },
   { inc_f6,	INC,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { u_isbc_f7,	ISB,	ZERO_PAGE_X,	M_ZERX,	M_ZERX,	6,	0 },
   { setf_f8,	SED,	IMPLIED,	M_NONE,	M_FD,	2,	0 },
   { sbc_f9,	SBC,	ABSOLUTE_Y,	M_ABSY,	M_AC,	4,	1 },
   { nop_fa,	NOOP,	IMPLIED,	M_NONE,	M_NONE,	2,	0 },
   { u_isbc_fb,	ISB,	ABSOLUTE_Y,	M_ABSY,	M_ABSY,	7,	0 },
   { nop_fc,	NOOP,	ABSOLUTE_X,	M_NONE,	M_NONE,	4,	1 },
   { sbc_fd,	SBC,	ABSOLUTE_X,	M_ABSX,	M_AC,	4,	1 },
   { inc_fe,	INC,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
   { u_isbc_ff,	ISB,	ABSOLUTE_X,	M_ABSX,	M_ABSX,	7,	0 },
};

