/*
 * $Id: vic.h,v 1.2 1996/07/29 23:25:42 ettore Exp ettore $
 *
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice.
 *
 *
 * Header file for VIC chip emulation.
 *
 * Written by
 *   Ettore Perazzoli (ettore@comm2000.it)
 *
 *
 * $Log: vic.h,v $
 * Revision 1.2  1996/07/29 23:25:42  ettore
 * *** empty log message ***
 *
 * Revision 1.1  1996/04/01 05:49:09  ettore
 * Initial revision
 *
 */

#ifndef _VIC_H
#define _VIC_H

#define NEEDS_NormalGetTextData
#define NEEDS_NormalGetColorData
#define NEEDS_NormalGetBgDataFromRegister

#include "raster.h"

#if defined (_VIC_C)
#define BORD_HEIGHT  20
#define BORD_WIDTH   20
#define SCR_COLS    300		/* full overscan x size -- probably not the real value */
#endif

#define VIC_NUMSPRITES 0


/* color definitions -- someone check these out please :) */

#define VIC_NUMCOLORS 16

#if defined (_VIC_C)
static char *vic_cnames[] =
{
  "#000000",			/* Black */
  "#ffffff",			/* White */
  "#f00000",			/* Red */
  "#00f0f0",			/* Cyan */
  "#600060",			/* Purple */
  "#00a000",			/* Green */
  "#0000f0",			/* Blue */
  "#d0d000",			/* Yellow */
  "#c0a000",			/* Orange */
  "#ffa000",			/* Light Orange */
  "#f08080",			/* Pink */
  "#00ffff",			/* Light Cyan */
  "#ff00ff",			/* Light Purple */
  "#00ff00",			/* Light Green */
  "#00a0ff",			/* Light Blue */
  "#ffff00"			/* Light Yellow */
};
#endif /* defined (_VIC_C) */


/* video mode definitions */

#define VIC_NORMAL_MODE             0
#define VIC_MULTICOLOR_MODE         1


/* Prototypes... */

void Vic_SetVModes (void);
Window Vic_Init (Display * disp, int scr_num, char *win_name, char *icon_name, char *res_class,
		 char *res_name, int *w, int *h, char *icon_data[], Colormap * cmap_return,
		 int exact_speed, int asleep, int refrate, Atom * wm_delwin);
void Vic_ArrangeWindow (int width, int height);
void Vic_Free (void);
void Vic_Pause (void);
void Vic_Restart (void);
void DoRaster (void);

#endif /* _VIC_H */
