/*
 * $Id: video_x.h,v 1.2 1996/07/29 23:32:30 ettore Exp ettore $
 *
 * This file is part of VICE, the Versatile Commodore Emulator
 * See README file for copyright notice.
 *
 * Header for X11 video interfacing.
 *
 * Written by
 *   Ettore Perazzoli (ettore@comm2000.it)
 *
 *
 * $Log: video_x.h,v $
 * Revision 1.2  1996/07/29 23:32:30  ettore
 * resize_window() and set_window_mapping().
 *
 * Revision 1.1  1996/04/01 05:46:39  ettore
 * Initial revision
 *
 */


#if !defined( _VIDEO_X_H)
#define _VIDEO_X_H

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#if defined( XPM )
#include <X11/xpm.h>
#endif


#if defined( __hpux )
#define _INCLUDE_POSIX_SOURCE
#endif


int alloc_colors (Display * disp, int scr_num, Window w, int n_colors, char *cnames[],
		  Colormap * cmap_return, PIXEL * pixels_return);
Window create_window (Display * disp, int scr_num, char *win_name, char *icon_name,
		      char *res_class, char *res_name, int width, int height, int minwidth,
		      int minheight, int maxwidth, int maxheight, char *icon_data[], int mapped,
		      Atom *wm_delwin);
void resize_window (Display * disp, Window w, int winwidth, int winheight);
void set_window_mapping (Display * disp, Window w, int mapped);

#endif  /* _VIDEO_X_H */
