--
Newsgroups: comp.emulators.cbm
From: borgen@stud.cs.uit.no (Borge Noest)
Subject: RomTrace.s - for the warped mind
Date: Sat, 11 Jun 1994 02:20:11 GMT

I needed to trace through some ROM code and store the PC, registers, and
processor status to compare with what my emulator does. In case anybody else
would need something like it here is the source (for Asm65 on the Amiga which
sadly has some addressing bugs. If you find a '-2' that looks wrong then just
remove it):
*	equ	$1000
loop	equ	$fd
lastaddrl equ $fd
lastaddrh equ $fe
data	equ	$fb

	db	00,$10

	LDA	$37
	SEC
	SBC	$2b
	TAX
	LDA	$38
	SBC	$2c
	JSR	$bdcd

	lda	#0
	sta	lastaddrl
	lda	#$a0
	sta	lastaddrh
	lda	#1
	sta	instsize
;rom out
	lda	#$7f
	sta	$dc0d

	sei
	lda	#54
	sta	$01

;write brk to all ram
	ldy	#>end+1
	sty	clear
	lda	#0
	tax
clear
	sta	$a000,x
	inx
	bne	clear
	iny
	sty	clear
	cpy	#$c0
	bcc	clear

	ldx	#$e0
	lda	#0
st	sta	$0110,x
	dex
	bne	st

;	sei
	lda	$0316
	sta	oldlow
	lda	$0317
	sta	oldhigh
	lda	#<blabla
	sta	$0316
	lda	#>blabla
	sta	$0317
	lda	#>end+1
	sta	data+1
	lda	#0
	sta	data
	cli

	LDA	$37
	SEC
	SBC	$2b
	TAX
	LDA	$38
	SBC	$2c
	JSR	$bdcd
;rom in
return
	sei
	lda	#55
	sta	$01

	lda	#$80
	sta	$dc0d

	lda	oldlow
	sta	$0316
	lda	oldhigh
	sta	$0317
	cli

;	cli
	rts

newbrk
blabla	equ	newbrk-2
;write n brk to last pc
	cld
	ldy	instsize
	lda	#0
brkloop
	sta	(lastaddrl),y
	dey
	bpl	brkloop

;save pc,regs,status
	ldy	#0
	tsx
	lda	$0101,x		;y
	sta	(data),y
	iny
	lda	$0102,x		;x
	sta	(data),y
	iny
	lda	$0103,x		;a
	sta	(data),y
	iny
	lda	$0104,x		;status
	sta	(data),y
	and	#~$10
	sta	$0104,x
	iny
	lda	$0106,x		;addrh
	sta	lastaddrh
	lda	$0105,x		;addl

	sec
	sbc	#2
	sta	lastaddrl
	sta	$0105,x		;addl
	sta	(data),y
	iny
	lda	lastaddrh
	sbc	#0
	sta	lastaddrh
	sta	$0106,x		;addh
	sta	(data),y

	clc
	lda	data
	adc	#6
	sta	data
	lda	data+1
	adc	#0
	sta	data+1

	bmi	return
;rom in
	lda	#55
	sta	$01
;get byte at pc

	ldy	#0
	lda	(lastaddrl),y
	tax

;get count from table
	ldy	sizetable,x
;	dey
	sty	instsize

;write n bytes from rom to ram
romloop
	lda	(lastaddrl),y
	sta	(lastaddrl),y
	dey
	bpl	romloop

;rom out
	lda	#54
	sta	$01

	inc	$d020
	inc	instcount+1
	bne	exit
	inc	$d021
	inc	instcount
exit
	jmp	$febc

oldlow db 0
oldhigh db 0
instsize db 1
instcount db 0,0

sizetable
	db	1,2,1,1,1,2,2,1,1,2,1,1,1,3,3,1		; 0
	db	2,2,1,1,1,2,2,1,1,3,1,1,1,3,3,1		; 1
	db	3,2,1,1,2,2,2,1,1,2,1,1,3,3,3,1
	db	2,2,1,1,1,2,2,1,1,3,1,1,1,3,3,1		; 3
	db	1,2,1,1,1,2,2,1,1,2,1,1,3,3,3,1
	db	2,2,1,1,1,2,2,1,1,3,1,1,1,3,3,1		; 5
	db	1,2,1,1,1,2,2,1,1,2,1,1,3,3,3,1
	db	2,2,1,1,1,2,2,1,1,3,1,1,1,3,3,1
	db	1,2,1,1,2,2,2,1,1,1,1,1,3,3,3,1		; 8
	db	2,2,1,1,2,2,2,1,1,3,1,1,1,3,1,1
	db	2,2,2,1,2,2,2,1,1,2,1,1,3,3,3,1		; a
	db	2,2,1,1,2,2,2,1,1,3,1,1,3,3,3,1
	db	2,2,1,1,2,2,2,1,1,2,1,1,3,3,3,1
	db	2,2,1,1,1,2,2,1,1,3,1,1,1,3,3,1
	db	2,2,1,1,2,2,2,1,1,2,1,1,3,3,3,1
	db	2,2,1,1,1,2,2,1,1,3,1,1,1,3,3,1

end

-- 
|/// borgen@stud.cs.uit.no (Brge Nst)   | Amiga 4000/040		 \\\|
|//  Box 218, 9001 Tromsoe, Norway	  | Remember to :-) when needed	  \\|
|/   The worlds northernmost university	  | Life is worth living.	   \|
#Disclaimer: This university does not speak for me.
-