/*
 * list c64 fonts
 * comment mark is '!'
 *
 *   Marko Makela (msmakela@hut.fi)
 *
 * Usage: listfont < chargen
 *
 */

#include <stdio.h>
#include <string.h>

#if 0
#define F_WIDTH  8
#define F_HEIGHT 8
#define F_SKIP   0
#else
#define F_WIDTH  6
#define F_HEIGHT 7
#define F_SKIP   1
#endif

#define BUFSIZE  24


void main (void)
{
    int c, i;
    int count = 0, ccount = 0, set = 1;

#if 0
    while ((c = getchar ()) != EOF) {
	printf ("%x-%02x: ", set, ccount);

	for (i = F_WIDTH-1; i >= 0; i--)
	    putc (c & (1 << i) ? '*' : ' ', stdout);

	printf ("\n");

	if (++count == F_HEIGHT) {
	    ccount++;
	    count = 0;
	    printf ("\n");
#ifdef F_SKIP
	    for (i = F_SKIP; i > 0 && getchar() != EOF; --i, ++ccount);
#endif
	}
	if (ccount == 256) {
	    set++;
	    ccount = 0;
	}
    }

#else

    /*
     * Create font from ascii images
     */

    char buf[BUFSIZE+1], *p;
    int  len, val;

    while (fgets (buf, BUFSIZE, stdin) != NULL) {
	val = 0;
	len = strlen(buf);
	p = buf + (--len);

	while ((len >= F_WIDTH) && isspace(*p))
	    *p-- = 0;			/* remove CR and excess whitespace */


	if (*buf != '!' && len >= F_WIDTH) {
	    p = buf + (len - F_WIDTH);

	    for (i = F_WIDTH-1; i >= 0; i--, p++)
		if (*p == '*')
		    val |= (1 << i);

	    printf ("%x-%02x: %s\t%02x\n", set, ccount, buf, val);

	    if (++count == F_HEIGHT) {
		ccount++;
		count = 0;
		printf ("\n");
	    }
	} /* valid */

	if (ccount == 256) {
	    set++;
	    ccount = 0;
	}
    }
#endif
}
