
/*
 * This file contains the modified opcode structure
 * for the misassembler script in readable format.
 *
 *  Compile: gcc -E moges.c
 */


#include "../mnemonic.h"
#include "../vmachine.h"

     /* 00 */	IMPLIED,	BRK
     /* 01 */	INDIRECT_X,	ORA
     /* 02 */	IMPLIED,	JAM
     /* 03 */	INDIRECT_X,	SLO
     /* 04 */	ZERO_PAGE,	NOOP
     /* 05 */	ZERO_PAGE,	ORA
     /* 06 */	ZERO_PAGE,	ASL
     /* 07 */	ZERO_PAGE,	SLO
     /* 08 */	IMPLIED,	PHP
     /* 09 */	IMMEDIATE,	ORA
     /* 0a */	ACCUMULATOR,	ASL
     /* 0b */	IMMEDIATE,	ANC
     /* 0c */	ABSOLUTE,	NOOP
     /* 0d */	ABSOLUTE,	ORA
     /* 0e */	ABSOLUTE,	ASL
     /* 0f */	ABSOLUTE,	SLO

     /* 10 */	RELATIVE,	BPL
     /* 11 */	INDIRECT_Y,	ORA
     /* 12 */	IMPLIED,	JAM
     /* 13 */	INDIRECT_Y,	SLO
     /* 14 */	ZERO_PAGE_X,	NOOP
     /* 15 */	ZERO_PAGE_X,	ORA
     /* 16 */	ZERO_PAGE_X,	ASL
     /* 17 */	ZERO_PAGE_X,	SLO
     /* 18 */	IMPLIED,	CLC
     /* 19 */	ABSOLUTE_Y,	ORA
     /* 1a */	IMPLIED,	NOOP
     /* 1b */	ABSOLUTE_Y,	SLO
     /* 1c */	ABSOLUTE_X,	NOOP
     /* 1d */	ABSOLUTE_X,	ORA
     /* 1e */	ABSOLUTE_X,	ASL
     /* 1f */	ABSOLUTE_X,	SLO

     /* 20 */	ABSOLUTE,	JSR
     /* 21 */	INDIRECT_X,	AND
     /* 22 */	IMPLIED,	JAM
     /* 23 */	INDIRECT_X,	RLA
     /* 24 */	ZERO_PAGE,	BIT
     /* 25 */	ZERO_PAGE,	AND
     /* 26 */	ZERO_PAGE,	ROL
     /* 27 */	ZERO_PAGE,	RLA
     /* 28 */	IMPLIED,	PLP
     /* 29 */	IMMEDIATE,	AND
     /* 2a */	ACCUMULATOR	ROL
     /* 2b */	IMMEDIATE,	ANC
     /* 2c */	ABSOLUTE,	BIT
     /* 2d */	ABSOLUTE,	AND
     /* 2e */	ABSOLUTE,	ROL
     /* 2f */	ABSOLUTE,	RLA

     /* 30 */	RELATIVE,	BMI
     /* 31 */	INDIRECT_Y,	AND
     /* 32 */	IMPLIED,	JAM
     /* 33 */	INDIRECT_Y,	RLA
     /* 34 */	ZERO_PAGE_X,	NOOP
     /* 35 */	ZERO_PAGE_X,	AND
     /* 36 */	ZERO_PAGE_X,	ROL
     /* 37 */	ZERO_PAGE_X,	RLA
     /* 38 */	IMPLIED,	SEC
     /* 39 */	ABSOLUTE_Y,	AND
     /* 3a */	IMPLIED,	NOOP
     /* 3b */	ABSOLUTE_Y,	RLA
     /* 3c */	ABSOLUTE_X,	NOOP
     /* 3d */	ABSOLUTE_X,	AND
     /* 3e */	ABSOLUTE_X,	ROL
     /* 3f */	ABSOLUTE_X,	RLA

     /* 40 */	IMPLIED,	RTI
     /* 41 */	INDIRECT_X,	EOR
     /* 42 */	IMPLIED,	JAM
     /* 43 */	INDIRECT_X,	SRE
     /* 44 */	ZERO_PAGE,	NOOP
     /* 45 */	ZERO_PAGE,	EOR
     /* 46 */	ZERO_PAGE,	LSR
     /* 47 */	ZERO_PAGE,	SRE
     /* 48 */	IMPLIED,	PHA
     /* 49 */	IMMEDIATE,	EOR
     /* 4a */	ACCUMULATOR	LSR
     /* 4b */	IMMEDIATE,	ASR
     /* 4c */	ABSOLUTE,	JMP
     /* 4d */	ABSOLUTE,	EOR
     /* 4e */	ABSOLUTE,	LSR
     /* 4f */	ABSOLUTE,	SRE

     /* 50 */	RELATIVE,	BVC
     /* 51 */	INDIRECT_Y,	EOR
     /* 52 */	IMPLIED,	JAM
     /* 53 */	INDIRECT_Y,	SRE
     /* 54 */	ZERO_PAGE_X,	NOOP
     /* 55 */	ZERO_PAGE_X,	EOR
     /* 56 */	ZERO_PAGE_X,	LSR
     /* 57 */	ZERO_PAGE_X,	SRE
     /* 58 */	IMPLIED,	CLI
     /* 59 */	ABSOLUTE_Y,	EOR
     /* 5a */	IMPLIED,	NOOP
     /* 5b */	ABSOLUTE_Y,	SRE
     /* 5c */	ABSOLUTE_X,	NOOP
     /* 5d */	ABSOLUTE_X,	EOR
     /* 5e */	ABSOLUTE_X,	LSR
     /* 5f */	ABSOLUTE_X,	SRE

     /* 60 */	IMPLIED,	RTS
     /* 61 */	INDIRECT_X,	ADC
     /* 62 */	IMPLIED,	JAM
     /* 63 */	INDIRECT_X,	RRA
     /* 64 */	ZERO_PAGE,	NOOP
     /* 65 */	ZERO_PAGE,	ADC
     /* 66 */	ZERO_PAGE,	ROR
     /* 67 */	ZERO_PAGE,	RRA
     /* 68 */	IMPLIED,	PLA
     /* 69 */	IMMEDIATE,	ADC
     /* 6a */	ACCUMULATOR,	ROR
     /* 6b */	IMMEDIATE,	ARR
     /* 6c */	INDIRECT,	JMP
     /* 6d */	ABSOLUTE,	ADC
     /* 6e */	ABSOLUTE,	ROR
     /* 6f */	ABSOLUTE,	RRA

     /* 70 */	RELATIVE,	BVS
     /* 71 */	INDIRECT_Y,	ADC
     /* 72 */	IMPLIED,	JAM
     /* 73 */	INDIRECT_Y,	RRA
     /* 74 */	ZERO_PAGE_X,	NOOP
     /* 75 */	ZERO_PAGE_X,	ADC
     /* 76 */	ZERO_PAGE_X,	ROR
     /* 77 */	ZERO_PAGE_X,	RRA
     /* 78 */	IMPLIED,	SEI
     /* 79 */	ABSOLUTE_Y,	ADC
     /* 7a */	IMPLIED,	NOOP
     /* 7b */	ABSOLUTE_Y,	RRA
     /* 7c */	ABSOLUTE_X,	NOOP
     /* 7d */	ABSOLUTE_X,	ADC
     /* 7e */	ABSOLUTE_X,	ROR
     /* 7f */	ABSOLUTE_X,	RRA

     /* 80 */	IMMEDIATE	NOOP
     /* 81 */	INDIRECT_X,	STA
     /* 82 */	IMMEDIATE,	NOOP
     /* 83 */	INDIRECT_X,	SAX
     /* 84 */	ZERO_PAGE,	STY
     /* 85 */	ZERO_PAGE,	STA
     /* 86 */	ZERO_PAGE,	STX
     /* 87 */	ZERO_PAGE,	SAX
     /* 88 */	IMPLIED,	DEY
     /* 89 */	IMMEDIATE,	NOOP
     /* 8a */	IMPLIED,	TXA
     /* 8b */	IMMEDIATE,	ANE
     /* 8c */	ABSOLUTE,	STY
     /* 8d */	ABSOLUTE,	STA
     /* 8e */	ABSOLUTE,	STX
     /* 8f */	ABSOLUTE,	SAX

     /* 90 */	RELATIVE,	BCC
     /* 91 */	INDIRECT_Y,	STA
     /* 92 */	IMPLIED,	JAM
     /* 93 */	INDIRECT_Y,	SHA
     /* 94 */	ZERO_PAGE_X,	STY
     /* 95 */	ZERO_PAGE_X,	STA
     /* 96 */	ZERO_PAGE_Y,	STX
     /* 97 */	ZERO_PAGE_Y,	SAX
     /* 98 */	IMPLIED,	TYA
     /* 99 */	ABSOLUTE_Y,	STA
     /* 9a */	IMPLIED,	TXS
     /* 9b */	ABSOLUTE_Y,	SHS
     /* 9c */	ABSOLUTE_X,	SHY
     /* 9d */	ABSOLUTE_X,	STA
     /* 9e */	ABSOLUTE_Y,	SHX
     /* 9f */	ABSOLUTE_Y,	SHA

     /* a0 */	IMMEDIATE,	LDY
     /* a1 */	INDIRECT_X,	LDA
     /* a2 */	IMMEDIATE,	LDX
     /* a3 */	INDIRECT_Y,	LAX
     /* a4 */	ZERO_PAGE,	LDY
     /* a5 */	ZERO_PAGE,	LDA
     /* a6 */	ZERO_PAGE,	LDX
     /* a7 */	ZERO_PAGE,	LAX
     /* a8 */	IMPLIED,	TAY
     /* a9 */	IMMEDIATE,	LDA
     /* aa */	IMPLIED,	TAX
     /* ab */	IMMEDIATE,	LXA
     /* ac */	ABSOLUTE,	LDY
     /* ad */	ABSOLUTE,	LDA
     /* ae */	ABSOLUTE,	LDX
     /* af */	ABSOLUTE,	LAX

     /* b0 */	RELATIVE,	BCS
     /* b1 */	INDIRECT_Y,	LDA
     /* b2 */	IMPLIED,	JAM
     /* b3 */	INDIRECT_Y,	LAX
     /* b4 */	ZERO_PAGE_X,	LDY
     /* b5 */	ZERO_PAGE_X,	LDA
     /* b6 */	ZERO_PAGE_Y,	LDX
     /* b7 */	ZERO_PAGE_Y,	LAX
     /* b8 */	IMPLIED,	CLV
     /* b9 */	ABSOLUTE_Y,	LDA
     /* ba */	IMPLIED,	TSX
     /* bb */	ABSOLUTE_Y,	LAS
     /* bc */	ABSOLUTE_X,	LDY
     /* bd */	ABSOLUTE_X,	LDA
     /* be */	ABSOLUTE_Y,	LDX
     /* bf */	ABSOLUTE_Y,	LAX

     /* c0 */	IMMEDIATE,	CPY
     /* c1 */	INDIRECT_X,	CMP
     /* c2 */	IMMEDIATE,	NOOP
     /* c3 */	INDIRECT_X,	DCP
     /* c4 */	ZERO_PAGE,	CPY
     /* c5 */	ZERO_PAGE,	CMP
     /* c6 */	ZERO_PAGE,	DEC
     /* c7 */	ZERO_PAGE,	DCP
     /* c8 */	IMPLIED,	INY
     /* c9 */	IMMEDIATE,	CMP
     /* ca */	IMPLIED,	DEX
     /* cb */	IMMEDIATE,	SBX
     /* cc */	ABSOLUTE,	CPY
     /* cd */	ABSOLUTE,	CMP
     /* ce */	ABSOLUTE,	DEC
     /* cf */	ABSOLUTE,	DCP

     /* d0 */	RELATIVE,	BNE
     /* d1 */	INDIRECT_Y,	CMP
     /* d2 */	IMPLIED,	JAM
     /* d3 */	INDIRECT_Y,	DCP
     /* d4 */	ZERO_PAGE_X,	NOOP
     /* d5 */	ZERO_PAGE_X,	CMP
     /* d6 */	ZERO_PAGE_X,	DEC
     /* d7 */	ZERO_PAGE_X,	DCP
     /* d8 */	IMPLIED,	CLD
     /* d9 */	ABSOLUTE_Y,	CMP
     /* da */	IMPLIED,	NOOP
     /* db */	ABSOLUTE_Y,	DCP
     /* dc */	ABSOLUTE_X,	NOOP
     /* dd */	ABSOLUTE_X,	CMP
     /* de */	ABSOLUTE_X,	DEC
     /* df */	ABSOLUTE_X,	DCP

     /* e0 */	IMMEDIATE,	CPX
     /* e1 */	INDIRECT_X,	SBC
     /* e2 */	IMMEDIATE,	NOOP
     /* e3 */	INDIRECT_X,	ISB
     /* e4 */	ZERO_PAGE,	CPX
     /* e5 */	ZERO_PAGE,	SBC
     /* e6 */	ZERO_PAGE,	INC
     /* e7 */	ZERO_PAGE,	ISB
     /* e8 */	IMPLIED,	INX
     /* e9 */	IMMEDIATE,	SBC
     /* ea */	IMPLIED,	NOP
     /* eb */	IMMEDIATE,	USBC
     /* ec */	ABSOLUTE,	CPX
     /* ed */	ABSOLUTE,	SBC
     /* ee */	ABSOLUTE,	INC
     /* ef */	ABSOLUTE,	ISB

     /* f0 */	RELATIVE,	BEQ
     /* f1 */	INDIRECT_Y,	SBC
     /* f2 */	IMPLIED,	JAM
     /* f3 */	INDIRECT_Y,	ISB
     /* f4 */	ZERO_PAGE_X,	NOOP
     /* f5 */	ZERO_PAGE_X,	SBC
     /* f6 */	ZERO_PAGE_X,	INC
     /* f7 */	ZERO_PAGE_X,	ISB
     /* f8 */	IMPLIED,	SED
     /* f9 */	ABSOLUTE_Y,	SBC
     /* fa */	IMPLIED,	NOOP
     /* fb */	ABSOLUTE_Y,	ISB
     /* fc */	ABSOLUTE_X,	NOOP
     /* fd */	ABSOLUTE_X,	SBC
     /* fe */	ABSOLUTE_X,	INC
     /* ff */	ABSOLUTE_X,	ISB


