/*
 * tpi.h - IEEE488 interface for the C64.
 *
 * Written by 
 *   Andre' Fachat (a.fachat@physik.tu-chemnitz.de)
 *
 * This file is part of VICE, the Versatile Commodore Emulator.
 * See README for copyright notice.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _TPI_H
#define _TPI_H

#define	TPI_PA		0
#define	TPI_PB		1
#define	TPI_PC		2
#define	TPI_ILR		2
#define	TPI_DDPA	3
#define	TPI_DDPB	4
#define	TPI_DDPC	5
#define	TPI_MIR		5
#define	TPI_CREG	6
#define	TPI_AIR		7

extern void reset_tpi(void);
extern void store_tpi(ADDRESS addr, BYTE byte);
extern BYTE read_tpi(ADDRESS addr);

#endif /* _TPI_H */
